------------------------------------------------
-- Loot Drop - show me what I got
--
-- @author Pawkette ( pawkette.heals@gmail.com )
-- @author Phinix "Loot Drop Reborn" branch ( PC NA @IllusoryID )
-- @author @Masteroshi430 "Loot Drop Deluxe" branch ( PC EU @Masteroshi430 )
------------------------------------------------

--Localization-----------------------------------------------------------------
local L = LootDrop_Strings:GetLanguage()
--Local constants--------------------------------------------------------------
local ADDON_VERSION						= "DEPRECATED"
local ADDON_NAME						= "LootDrop"
local LootDrop_sDefRushmik          	= "|cD3B830Rushmik|r"
local LootDrop_sDefPawkette         	= "|cFF66CCPawkette|r"
local LootDrop_sDefESOclassic         	= "|cFFFFFFESO classic|r"
local LootDrop_sDefDefault          	= L.sDefDefault
local LootDrop_sListBoxNo           	= L.sListBoxNo
local LootDrop_sListBoxStacked      	= L.sListBoxStacked
local LootDrop_sListBoxNotStacked   	= L.sListBoxNotStacked
local LootDrop_sListBoxStandard     	= L.sListBoxStandard
local LootDrop_sListBoxExtended     	= L.sListBoxExtended
local LootDrop_sListBoxHalfExtended     = L.sListBoxHalfExtended
local LootDrop_sListBoxValueNo      	= L.ValueNo
local LootDrop_sListBoxValueVendor   	= L.ValueVendor
local LootDrop_sListBoxValueTrade     	= L.ValueTrade
local LootDrop_sListBoxValueVaT     	= L.ValueVaT
local LootDrop_sListBoxGroupChar     	= L.GroupChar
local LootDrop_sListBoxGroupAcct     	= L.GroupAcct
local LootDrop_sListBoxGroupBoth     	= L.GroupBoth
local LootDrop_SoulGem = GetItemLinkName("|H1:item:33271:0:0:0:0:0:0:0:0:0:0:0:0:0:0:36:0:0:0:0:0|h|h")
local LootDrop_EmptyGem = GetItemLinkName("|H1:item:33265:0:0:0:0:0:0:0:0:0:0:0:0:0:0:36:0:0:0:0:0|h|h")
--Libraries--------------------------------------------------------------------
local CBM = CALLBACK_MANAGER
local LAM2 = LibAddonMenu2
if ( not LAM2 ) then return end
--Icons------------------------------------------------------------------------
local LootDrop_sApIcon     				= [[/lootdrop/textures/ap_up.dds]]
local LootDrop_sXpIcon     				= [[/lootdrop/textures/xp_up.dds]]
local LootDrop_sRapportUpIcon			= [[/lootdrop/textures/rapport_up.dds]]
local LootDrop_sRapportDownIcon			= [[/lootdrop/textures/rapport_down.dds]]
local LootDrop_sSkillXpIcon				= [[/lootdrop/textures/skill_up.dds]]
local LootDrop_sTVIcon     				= [[esoui/art/icons/icon_telvarstone.dds]]
local LootDrop_sWVoucherIcon     		= [[esoui/art/icons/icon_writvoucher.dds]]
local LootDrop_sUndauntedIcon     		= [[esoui/art/icons/undaunted_gold_key_01.dds]]
local LootDrop_sTransmuteIcon     		= [[esoui/art/currency/currency_seedcrystal_mipmap.dds]]
local LootDrop_sETicketIcon     		= [[esoui/art/currency/icon_eventticket_loot.dds]]
local LootDrop_sAnvilXpIcon         	= [[esoui/art/icons/servicemappins/servicepin_smithy.dds]]
local LootDrop_sWoodXpIcon          	= [[esoui/art/icons/servicemappins/servicepin_woodworking.dds]]
local LootDrop_sAlchimyXpIcon       	= [[esoui/art/icons/servicemappins/servicepin_alchemy.dds]]
local LootDrop_sClothierXpIcon      	= [[esoui/art/icons/servicemappins/servicepin_outfitter.dds]]
local LootDrop_sEnchanterXpIcon     	= [[esoui/art/icons/servicemappins/servicepin_enchanting.dds]]
local LootDrop_sProvisioningXpIcon  	= [[esoui/art/icons/servicemappins/servicepin_inn.dds]]
local LootDrop_sJewelrycraftingXpIcon	= [[esoui/art/icons/servicemappins/servicepin_jewelrycrafting.dds]]
local LootDrop_sMagesGuildXpIcon    	= [[esoui/art/icons/servicemappins/servicepin_magesguild.dds]]
local LootDrop_sFighterGuildXpIcon  	= [[esoui/art/icons/servicemappins/servicepin_fightersguild.dds]]
local LootDrop_sThievesXpIcon       	= [[/esoui/art/icons/servicemappins/servicepin_thievesguild.dds]]
local LootDrop_sBrotherhoodXpIcon   	= [[/esoui/art/icons/poi/poi_darkbrotherhood_complete.dds]]
local LootDrop_sOthersGuildXpIcon   	= [[esoui/art/icons/poi/poi_groupinstance_complete.dds]]
local LootDrop_sBooksXpIcon         	= [[esoui/art/mainmenu/menubar_journal_up.dds]]
local LootDrop_sFenceXpIcon         	= [[/esoui/art/icons/servicemappins/servicepin_fence.dds]]
local LootDrop_sBgTexture           	= [[/lootdrop/textures/default_bg.dds]]
local LootDrop_sRarityTexture       	= [[/lootdrop/textures/default_rarity.dds]]
local LootDrop_sEndeavorIcon            = [[/esoui/art/currency/currency_seals_of_endeavor_32.dds]]
--Default Values for SavedVars-------------------------------------------------
local LootDrop_Defaults =
{
	displayduration			= 10,
	maxstacks			    = 10,
	experience				= LootDrop_sListBoxHalfExtended,
	companionXP				= LootDrop_sListBoxHalfExtended,
	companionRapport		= LootDrop_sListBoxExtended,
	coin					= LootDrop_sListBoxExtended,
	alliance				= LootDrop_sListBoxHalfExtended,
	telvar					= LootDrop_sListBoxExtended,
	wvoucher				= LootDrop_sListBoxExtended,
	undaunted				= LootDrop_sListBoxExtended,
	transmute				= LootDrop_sListBoxExtended,
	eticket					= LootDrop_sListBoxExtended,
	Endeavor                = LootDrop_sListBoxExtended,
	loot					= true,
	mailloot				= true,
	nameloot				= true,
	stackloot				= true,
	stackval				= false,
	styleloot				= false,
	oldicons				= true,
	Junk					= false,
	Skills					= LootDrop_sListBoxExtended,	-- Skills Progress
	SkillNames				= false,						-- Show Skill Names
	Craft					= true, 						-- Craft XP
	Fence					= true,							-- Fence XP
	Books					= true,							-- Book Knowledge
	Guilds					= true,							-- Guild Reputation
	Weapon					= false,						-- Weapon Skill Tree
	Armor					= false,						-- Armor Skill Tree
	World					= true,							-- World Skill Tree
	AvA						= false,						-- AvA Skill Tree
	sListStyle				= LootDrop_sDefESOclassic,
	width					= 314, --220
	height					= 40, --45
	padding					= 5,
	FontSize				= 18,
	rarity					= false,
	MoveUp					= true,
	lootdrop_x				= 0,
	lootdrop_y				= 0,
	valueloot				= 0,
	valueround				= 2,
	version					= 0,
	lootdrop_gname			= 0,
	lootdrop_lock			= true,
	nodata					= false,
	DbgLogMineQlty			= ITEM_QUALITY_MAGIC,
	DbgLogOthersQlty		= ITEM_QUALITY_ARCANE,
	DbgLogMine				= true,
	DbgLogOthers			= true,
	DbgLogGold				= false,
	DbgLogXP				= false,
	DbgLogAP				= false,
	DbgLogTelvar			= false,
	DbgLogWritVoucher		= false,
	DbgLogUndauntedKey		= false,
	DbgLogTransmuteCrystal	= false,
	DbgLogEventTicket		= false,
	DbgLogEndeavor          = false,
	DbgLogCXp				= false,
	DbgLogCRpt				= true,
	DbgLogCraftXP			= false,
	DbgLogFenceXP			= false,
	DbgLogBookKnowledge		= false,
	DbgLogGuildRep			= false,
	DbgLogWeapon			= false,
	DbgLogArmor				= false,
	DbgLogWorld				= false,
	DbgLogAvA				= false,
	DbgLogTime				= false,
	DbgLogItemStyle			= false,
	DbgLogItemTrait			= true,
	DbgLogItemValue			= true,
	DbgLogTag				= false,
	DbgHideGUI				= false,
	HideMeters              = true,
	LootDrop_sCustomBgTexture = "DEFAULT",
}
--Local Functions--------------------------------------------------------------
local tinsert           = table.insert
local tremove           = table.remove
local zo_strsplit       = zo_strsplit
local ZO_ColorDef       = ZO_ColorDef
local zo_parselink      = ZO_LinkHandler_ParseLink
local zo_min            = zo_min
local CBM               = CALLBACK_MANAGER
local _
--LootDrop Objects defined in other files--------------------------------------
local LootDropFade      = LootDropFade
local LootDropSlide     = LootDropSlide
local LootDropPop       = LootDropPop
-------------------------------------------------------------------------------
--- Flags for updating UI aspects
local DirtyFlags =
{
	LAYOUT = 1 -- we've added or removed a droppable
}

--LootDropPool-----------------------------------------------------------------
local LootDropPool = ZO_Object:Subclass()
-------------------------------------------------------------------------------
function LootDropPool:New()
	return ZO_Object.New( self )
end
-------------------------------------------------------------------------------
function LootDropPool:Initialize( create, reset )
	self._create    = create
	self._reset     = reset
	self._active    = {}
	self._inactive  = {}
	self._controlId = 0
end
-------------------------------------------------------------------------------
function LootDropPool:GetNextId()
	self._controlId = self._controlId + 1
	return self._controlId
end
-------------------------------------------------------------------------------
function LootDropPool:Active()
	return self._active
end
-------------------------------------------------------------------------------
function LootDropPool:Acquire()
	local result = nil
	if ( #self._inactive > 0 ) then
	   tremove( self._inactive, 1 ) -- SOLUTION FOR THE NEW DROPS DISAPEARING WITH THE OLD ONES ? 
	   result = self._create()      -- SOLUTION FOR THE NEW DROPS DISAPEARING WITH THE OLD ONES ?  
	   --result = tremove( self._inactive, 1 )
	else
		result = self._create()
	end

	tinsert( self._active, result ) 
	return result, #self._active
end
-------------------------------------------------------------------------------
function LootDropPool:Get(key)
	if ( not key or type(key) ~= 'number' or key > #self._active ) then
		return nil
	end

	return self._active[ key ]
end
-------------------------------------------------------------------------------
function LootDropPool:Release(object)
	local i = 1
	while( i <= #self._active ) do
		if ( self._active[ i ] == object ) then
			self._reset( object, i )
			tinsert( self._inactive, tremove( self._active, i ) )
			break
		else
			i = i + 1 
		end
	end
end
-------------------------------------------------------------------------------
function LootDropPool:ReleaseAll()
	for i=#self._active,1,-1 do 
		tinsert( self._inactive, tremove( self._active, i ) )
	end
end
-------------------------------------------------------------------------------

--LootDropConfig---------------------------------------------------------------
local LootDropConfig                   = ZO_Object:Subclass()
--Constants--------------------------------------------------------------------
LootDropConfig.EVENT_TOGGLE_LOOT			= 'LOOTDROP_TOGGLE_LOOT'
LootDropConfig.EVENT_TOGGLE_MAIL_LOOT		= 'LOOTDROP_TOGGLE_MAIL_LOOT'
LootDropConfig.EVENT_TOGGLE_GROUP_NAME		= 'LOOTDROP_TOGGLE_GROUP_NAME'
LootDropConfig.EVENT_TOGGLE_COIN			= 'LOOTDROP_TOGGLE_COIN'
LootDropConfig.EVENT_TOGGLE_XP				= 'LOOTDROP_TOGGLE_XP'
LootDropConfig.EVENT_TOGGLE_AP				= 'LOOTDROP_TOGGLE_AP'
LootDropConfig.EVENT_TOGGLE_TV				= 'LOOTDROP_TOGGLE_TV'
LootDropConfig.EVENT_TOGGLE_WVOUCHER		= 'LOOTDROP_TOGGLE_WVOUCHER'
LootDropConfig.EVENT_TOGGLE_UNDAUNTED		= 'LOOTDROP_TOGGLE_UNDAUNTED'
LootDropConfig.EVENT_TOGGLE_TRANSMUTE		= 'LOOTDROP_TOGGLE_TRANSMUTE'
LootDropConfig.EVENT_TOGGLE_ETICKET			= 'LOOTDROP_TOGGLE_ETICKET'
LootDropConfig.EVENT_TOGGLE_ENDEAVOR		= 'LOOTDROP_TOGGLE_ENDEAVOR'
LootDropConfig.EVENT_TOGGLE_JUNK			= 'LOOTDROP_TOGGLE_JUNK'
LootDropConfig.EVENT_TOGGLE_COMPANION_XP	= 'LOOTDROP_TOGGLE_COMPANION_XP'
LootDropConfig.EVENT_TOGGLE_COMPANION_RP	= 'LOOTDROP_TOGGLE_COMPANION_RP'
LootDropConfig.EVENT_TOGGLE_SKILL_XP		= 'LOOTDROP_TOGGLE_SKILL_XP'
LootDropConfig.EVENT_TOGGLE_SKILL			= 'LOOTDROP_TOGGLE_SKILL'
LootDropConfig.EVENT_TOGGLE_DEBUGLOG		= 'LOOTDROP_TOGGLE_DEBUGLOG'
LootDropConfig.EVENT_TOGGLE_STYLE			= 'LOOTDROP_TOGGLE_STYLE'
LootDropConfig.EVENT_TOGGLE_LOCK			= 'LOOTDROP_TOGGLE_LOCK'
LootDropConfig.EVENT_TOGGLE_RARITY			= 'LOOTDROP_TOGGLE_RARITY'
LootDropConfig.EVENT_TOGGLE_MOVEUP			= 'LOOTDROP_TOGGLE_MOVEUP'
LootDropConfig.EVENT_CHANGE_DIMENSIONS		= 'LOOTDROP_CHANGE_DIMENSIONS'

-------------------------------------------------------------------------------
function LootDropConfig:New( ... )
	local result = ZO_Object.New( self )
	result:Initialize( ... )
	return result
end
-------------------------------------------------------------------------------
function LootDropConfig:Initialize( db )
	self.db = db
	
	local panelData = {
		type = "panel",
		name = ADDON_NAME,
		displayName = L.AddonName,
		author = "|c3CB371@Masteroshi430|r, |cFF66CCPawkette|r, |cAA0000Flagrick|r, Ayantir, |c66ccffPhinix|r",
		version = ADDON_VERSION,
		slashCommand = "/lootdrop",
		registerForRefresh = true,
		registerForDefaults = true,
		website = "https://www.esoui.com/downloads/info3304-LootDropDeluxe.html"
	}

	LAM2:RegisterAddonPanel(ADDON_NAME, panelData)

	--local variables
	local qualityChoices = {}
	local reverseQualityChoices = {}
	for i = 0, ITEM_QUALITY_LEGENDARY do
		local color = GetItemQualityColor(i)
		local qualName = color:Colorize(GetString("SI_ITEMQUALITY", i))
		qualityChoices[i] = qualName
		reverseQualityChoices[qualName] = i
	end
	
	local optionsTable = {
		------------LOOT WINDOW OPTIONS--------------
		{
			type = 'submenu',
			name = L.GeneralHeader,
			tooltip = '',
			controls = {
			[1] = {
					type = "checkbox",
					name = L.Loot,
					tooltip = L.LootTip,
					getFunc = function() return self.db.loot end,
					setFunc = function(value) self:ToggleLoot(value) end,
					width = "full",
					default = LootDrop_Defaults.loot
					},
			[2] = {
					type = "checkbox",
					name = L.LootHistory,
					tooltip = L.LootHistoryTip,
					getFunc = function() return self.db.loothistory end,
					setFunc = function(value) self:ToggleLootHistory(value) end,
					width = "full",
					},
			[3] = {
					type = "checkbox",
					name = L.MailLoot,
					tooltip = L.MailLootTip,
					getFunc = function() return self.db.mailloot end,
					setFunc = function(value) self:ToggleMailLoot(value) end,
					width = "full",
					disabled = function() return not self.db.loot end,
					default = LootDrop_Defaults.mailloot
					},
			[4] = {
					type = "dropdown",
					name = L.Gold,
					tooltip = L.GoldTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStandard, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.coin end,
					setFunc = function(valueString) self:ToggleCoin(valueString) end,
					width = "full",
					default = LootDrop_Defaults.coin
					},
			[5] = {
					type = "dropdown",
					name = L.Experience,
					tooltip = L.ExperienceTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStandard, LootDrop_sListBoxHalfExtended, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.experience end,
					setFunc = function(valueString) self:ToggleXP(valueString) end,
					width = "full",
					default = LootDrop_Defaults.experience
					},
			[6] = {
					type = "dropdown",
					name = L.AlliancePoints,
					tooltip = L.AlliancePointsTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxHalfExtended, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.alliance end,
					setFunc = function(valueString) self:ToggleAP(valueString) end,
					width = "full",
					default = LootDrop_Defaults.alliance
					},
			[7] = {
					type = "dropdown",
					name = L.TelvarStones,
					tooltip = L.TelvarStonesTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.telvar end,
					setFunc = function(valueString) self:ToggleTV(valueString) end,
					width = "full",
					default = LootDrop_Defaults.telvar
					},
			[8] = {
					type = "dropdown",
					name = L.WritVouchers,
					tooltip = L.WritVouchersTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.wvoucher end,
					setFunc = function(valueString) self:ToggleWVoucher(valueString) end,
						width = "full",
					default = LootDrop_Defaults.wvoucher
					},
			[9] = {
					type = "dropdown",
					name = L.UndauntedKeys,
					tooltip = L.UndauntedKeysTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.undaunted end,
					setFunc = function(valueString) self:ToggleUndaunted(valueString) end,
						width = "full",
					default = LootDrop_Defaults.undaunted
					},
			[10] = {
					type = "dropdown",
					name = L.TransmuteCrystals,
					tooltip = L.TransmuteCrystalsTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.transmute end,
					setFunc = function(valueString) self:ToggleTransmute(valueString) end,
						width = "full",
					default = LootDrop_Defaults.transmute
					},
			[11] = {
					type = "dropdown",
					name = L.EventTickets,
					tooltip = L.EventTicketsTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.eticket end,
					setFunc = function(valueString) self:ToggleETicket(valueString) end,
						width = "full",
					default = LootDrop_Defaults.eticket
					},
			[12] = {
					type = "dropdown",
					name = L.Endeavor,
					tooltip = L.EndeavorTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.Endeavor end,
					setFunc = function(valueString) self:ToggleEndeavor(valueString) end,
						width = "full",
					default = LootDrop_Defaults.Endeavor
					},
			[13] = {
					type = "dropdown",
					name = L.CompanionXP,
					tooltip = L.CompanionXPTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStandard, LootDrop_sListBoxHalfExtended, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.companionXP end,
					setFunc = function(valueString) self:ToggleCompanionXP(valueString) end,
					width = "full",
					default = LootDrop_Defaults.companionXP
					},
			[14] = {
					type = "dropdown",
					name = L.CompanionRapport,
					tooltip = L.CompanionRapportTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStandard, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.companionRapport end,
					setFunc = function(valueString) self:ToggleCompanionRapport(valueString) end,
					width = "full",
					default = LootDrop_Defaults.companionRapport
					},
			[15] = {
					type = "header",
					name = L.SkillDisplay,
					},
			[16] = {
					type = "dropdown",
					name = L.SkillTrees,
					tooltip = L.SkillTreesTip,
					choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked, LootDrop_sListBoxExtended},
					getFunc = function() return self.db.Skills end,
					setFunc = function(value) self:ToggleSkillXP(value) end,
					width = "full",
					default = LootDrop_Defaults.Skills
					},
			[17] = {
					type = "checkbox",
					name = L.CraftXP,
					tooltip = L.CraftXPTip,
					getFunc = function() return self.db.Craft end,
					setFunc = function(value) self:ToggleCraftXP(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.Craft
					},
			[18] = {
					type = "checkbox",
					name = L.FenceXP,
					tooltip = L.FenceXPTip,
					getFunc = function() return self.db.Fence end,
					setFunc = function(value) self:ToggleFenceXP(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.Fence
					},
			[19] = {
					type = "checkbox",
					name = L.BookKnowledge,
					tooltip = L.BookKnowledgeTip,
					getFunc = function() return self.db.Books end,
					setFunc = function(value) self:ToggleBookXP(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.Books
					},
			[20] = {
					type = "checkbox",
					name = L.GuildReputation,
					tooltip = L.GuildReputationTip,
					getFunc = function() return self.db.Guilds end,
					setFunc = function(value) self:ToggleGuildXP(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.Guilds
					},
			[21] = {
					type = "checkbox",
					name = L.WeaponXP,
					tooltip = L.WeaponXPTip,
					getFunc = function() return self.db.Weapon end,
					setFunc = function(value) self:ToggleWeapon(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.Weapon
					},
			[22] = {
					type = "checkbox",
					name = L.ArmorXP,
					tooltip = L.ArmorXPTip,
					getFunc = function() return self.db.Armor end,
					setFunc = function(value) self:ToggleArmor(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.Armor
					},
			[23] = {
					type = "checkbox",
					name = L.WorldXP,
					tooltip = L.WorldXPTip,
					getFunc = function() return self.db.World end,
					setFunc = function(value) self:ToggleWorld(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.World
					},
			[24] = {
					type = "checkbox",
					name = L.AvAXP,
					tooltip = L.AvAXPTip,
					getFunc = function() return self.db.AvA end,
					setFunc = function(value) self:ToggleAvA(value) end,
					width = "half",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.AvA
					},
			[25] = {
					type = "checkbox",
					name = L.SkillNames,
					tooltip = L.SkillNamesTip,
					getFunc = function() return self.db.SkillNames end,
					setFunc = function(value) self.db.SkillNames = value end,
					width = "full",
					disabled = function(value) return self.db.Skills == LootDrop_sListBoxNo end,
					default = LootDrop_Defaults.SkillNames
					},
			[26] = {
					type = "checkbox",
					name = L.OldIcons,
					tooltip = L.OldIconsTip,
					getFunc = function() return self.db.oldicons end,
					setFunc = function(value) self.db.oldicons = value end,
					width = "full",
					disabled = function(value) return (self.db.Guilds == false or self.db.Skills == LootDrop_sListBoxNo) end,
					default = LootDrop_Defaults.oldicons
					},
			[27] = {
					type = "header",
					name = L.DisplayOptions,
					},
			[28] = {
					type = "checkbox",
					name = L.NameLoot,
					tooltip = L.NameLootTip,
					getFunc = function() return self.db.nameloot end,
					setFunc = function(value) self:ToggleNameLoot(value) end,
					width = "full",
					disabled = function() return not self.db.loot end,
					default = LootDrop_Defaults.nameloot
					},
			[29] = {
					type = "checkbox",
					name = L.InventoryStacks,
					tooltip = L.InventoryStacksTip,
					getFunc = function() return self.db.stackloot end,
					setFunc = function(value) self:ToggleStackLoot(value) end,
					width = "full",
					disabled = function() return not self.db.loot end,
					default = LootDrop_Defaults.stackloot
					},
			[30] = {
					type = "checkbox",
					name = L.StyleLoot,
					tooltip = L.StyleLootTip,
					getFunc = function() return self.db.styleloot end,
					setFunc = function(value) self:ToggleStyleLoot(value) end,
					width = "full",
					disabled = function() return not self.db.loot end,
					default = LootDrop_Defaults.styleloot
					},
			[31] = {
					type = "checkbox",
					name = L.Junk,
					tooltip = L.JunkTip,
					getFunc = function() return self.db.Junk end,
					setFunc = function(value) self:ToggleJunk(value) end,
					width = "full",
					default = LootDrop_Defaults.Junk
					},
					
			[32] = {
					type = "checkbox",
					name = L.HideMeters,
					tooltip = L.HideMetersTip,
					getFunc = function() return self.db.HideMeters end,
					setFunc = function(value) self:ToggleHideMeters(value) end,
					width = "full",
					default = LootDrop_Defaults.HideMeters
					},
			[33] = {
					type = "checkbox",
					name = L.HideGUI,
					tooltip = L.HideGUITip,
					getFunc = function() return self.db.DbgHideGUI end,
					setFunc = function(value) self:ToggleHideGUI(value) end,
					width = "full",
					disabled = function() return (not self.db.DbgLogMine and not self.db.DbgLogOthers) end,
					default = LootDrop_Defaults.DbgHideGUI
					},
				},
			},
		------------CHAT LOG--------------
		{
			type = 'submenu',
			name = L.ChatOptionHeader,
			tooltip = '',
			controls = {
			[1] = {
					type = "checkbox",
					name = L.ShowInChat,
					tooltip = L.ShowInChatTip,
					getFunc = function() return self.db.DbgLogMine end,
					setFunc = function(value) self:ToggleDbgLog(value) end,
					width = "half",
					default = LootDrop_Defaults.DbgLogMine
					},
			[2] = {
					type = "dropdown",
					name = L.QualityCap,
					tooltip = L.MyLootQCapTip,
					choices = qualityChoices,
					getFunc = function() return qualityChoices[self.db.DbgLogMineQlty] end,
					setFunc = function(choice) self.db.DbgLogMineQlty = reverseQualityChoices[choice] end,
					width = "half",
					disabled = function() return not self.db.DbgLogMine end,
					default = qualityChoices[LootDrop_Defaults.DbgLogMineQlty],
					},
			[3] = {
					type = "checkbox",
					name = L.ShowGroupLoot,
					tooltip = L.ShowGroupLootTip,
					getFunc = function() return self.db.DbgLogOthers end,
					setFunc = function(value) self:ToggleOthersLog(value) end,
					width = "half",
					default = LootDrop_Defaults.DbgLogOthers
					},
			[4] = {
					type = "dropdown",
					name = L.QualityCap,
					tooltip = L.GroupLootQCapTip,
					choices = qualityChoices,
					getFunc = function() return qualityChoices[self.db.DbgLogOthersQlty] end,
					setFunc = function(choice) self.db.DbgLogOthersQlty = reverseQualityChoices[choice] end,
					width = "half",
					disabled = function() return not self.db.DbgLogOthers end,
					default = qualityChoices[LootDrop_Defaults.DbgLogOthersQlty],
					},
			[5] = {
					type = "dropdown",
					name = L.GroupNameFormat,
					tooltip = L.GroupNameFormatTip,
					choices = {LootDrop_sListBoxGroupChar, LootDrop_sListBoxGroupAcct, LootDrop_sListBoxGroupBoth},
					getFunc = function() 
						local values = {[0] = LootDrop_sListBoxGroupChar, [1] = LootDrop_sListBoxGroupAcct, [2] = LootDrop_sListBoxGroupBoth}
						local opt = self.db.lootdrop_gname
						if (opt ~= 0 and opt ~= 1 and opt ~=2) then opt = 0 end
						return values[opt]
					end,
					setFunc = function(valueString)
						local values = {[LootDrop_sListBoxGroupChar] = 0, [LootDrop_sListBoxGroupAcct] = 1, [LootDrop_sListBoxGroupBoth] = 2}
						self:ToggleGroupName(values[valueString])
					end,
					width = "full",
					disabled = function() return not self.db.DbgLogOthers end,
					default = LootDrop_Defaults.lootdrop_gname
					},
			[6] = {
					type = "checkbox",
					name = L.LogGold,
					tooltip = L.LogGoldTip,
					getFunc = function() return self.db.DbgLogGold end,
					setFunc = function(value) self:ToggleDbgLogGold(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogGold
					},
			[7] = {
					type = "checkbox",
					name = L.LogXP,
					tooltip = L.LogXPTip,
					getFunc = function() return self.db.DbgLogXP end,
					setFunc = function(value) self:ToggleDbgLogXP(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogXP
					},
			[8] = {
					type = "checkbox",
					name = L.LogAP,
					tooltip = L.LogAPTip,
					getFunc = function() return self.db.DbgLogAP end,
					setFunc = function(value) self:ToggleDbgLogAP(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogAP
					},
			[9] = {
					type = "checkbox",
					name = L.LogTelvar,
					tooltip = L.LogTelvarTip,
					getFunc = function() return self.db.DbgLogTelvar end,
					setFunc = function(value) self:ToggleDbgLogTelvar(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogTelvar
					},
			[10] = {
					type = "checkbox",
					name = L.LogWritVoucher,
					tooltip = L.LogWritVoucherTip,
					getFunc = function() return self.db.DbgLogWritVoucher end,
					setFunc = function(value) self:ToggleDbgLogWritVoucher(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogWritVoucher
					},
			[11] = {
					type = "checkbox",
					name = L.LogUndauntedKey,
					tooltip = L.LogUndauntedKeyTip,
					getFunc = function() return self.db.DbgLogUndauntedKey end,
					setFunc = function(value) self:ToggleDbgLogUndauntedKey(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogUndauntedKey
					},
			[12] = {
					type = "checkbox",
					name = L.LogTransmuteCrystal,
					tooltip = L.LogTransmuteCrystalTip,
					getFunc = function() return self.db.DbgLogTransmuteCrystal end,
					setFunc = function(value) self:ToggleDbgLogTransmuteCrystal(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogTransmuteCrystal
					},
			[13] = {
					type = "checkbox",
					name = L.LogEventTicket,
					tooltip = L.LogEventTicketTip,
					getFunc = function() return self.db.DbgLogEventTicket end,
					setFunc = function(value) self:ToggleDbgLogEventTicket(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogEventTicket
					},
			[14] = {
					type = "checkbox",
					name = L.LogEndeavor,
					tooltip = L.LogEndeavorTip,
					getFunc = function() return self.db.DbgLogEndeavor end,
					setFunc = function(value) self:ToggleDbgLogEndeavor(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogEndeavor
					},
			[15] = {
					type = "checkbox",
					name = L.LogCompanionXP,
					tooltip = L.LogCompanionXPTip,
					getFunc = function() return self.db.DbgLogCXp end,
					setFunc = function(value) self:ToggleDbgLogCXp(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogCXp
					},
			[16] = {
					type = "checkbox",
					name = L.LogCompanionRapport,
					tooltip = L.LogCompanionRapportTip,
					getFunc = function() return self.db.DbgLogCRpt end,
					setFunc = function(value) self:ToggleDbgLogRapport(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogCRpt
					},
			[17] = {
					type = "checkbox",
					name = L.LogCraftXP,
					tooltip = L.LogCraftXPTip,
					getFunc = function() return self.db.DbgLogCraftXP end,
					setFunc = function(value) self:ToggleDbgLogCraftXP(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogCraftXP
					},
			[18] = {
					type = "checkbox",
					name = L.LogFenceXP,
					tooltip = L.LogFenceXPTip,
					getFunc = function() return self.db.DbgLogFenceXP end,
					setFunc = function(value) self:ToggleDbgLogFenceXP(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogFenceXP
					},
			[19] = {
					type = "checkbox",
					name = L.LogBookKnowledge,
					tooltip = L.LogBookKnowledgeTip,
					getFunc = function() return self.db.DbgLogBookKnowledge end,
					setFunc = function(value) self:ToggleDbgLogBookKnowledge(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogBookKnowledge
					},
			[20] = {
					type = "checkbox",
					name = L.LogGuildRep,
					tooltip = L.LogGuildRepTip,
					getFunc = function() return self.db.DbgLogGuildRep end,
					setFunc = function(value) self:ToggleDbgLogGuildRep(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogGuildRep
					},
			[21] = {
					type = "checkbox",
					name = L.LogWeaponXP,
					tooltip = L.LogWeaponXPTip,
					getFunc = function() return self.db.DbgLogWeapon end,
					setFunc = function(value) self:ToggleDbgLogWeapon(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogWeapon
					},
			[22] = {
					type = "checkbox",
					name = L.LogArmorXP,
					tooltip = L.LogArmorXPTip,
					getFunc = function() return self.db.DbgLogArmor end,
					setFunc = function(value) self:ToggleDbgLogArmor(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogArmor
					},
			[23] = {
					type = "checkbox",
					name = L.LogWorldXP,
					tooltip = L.LogWorldXPTip,
					getFunc = function() return self.db.DbgLogWorld end,
					setFunc = function(value) self:ToggleDbgLogWorld(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogWorld
					},
			[24] = {
					type = "checkbox",
					name = L.LogAvAXP,
					tooltip = L.LogAvAXPTip,
					getFunc = function() return self.db.DbgLogAvA end,
					setFunc = function(value) self:ToggleDbgLogAvA(value) end,
					width = "full",
					default = LootDrop_Defaults.DbgLogAvA
					},
				},
			},
		------------DIM & STYLE--------------
		{
			type = 'submenu',
			name = L.DimStyleHeader,
			tooltip = '',
			controls = {
			[1] = {
					type = "header",
					name = L.LootAppearance,
					},
			[2] = {
					type = "slider",
					name = L.DisplayDuration,
					tooltip = L.DisplayDurationTip,
					min = 1,
					max = 30,
					step = 1,
					getFunc = function() return self.db.displayduration end,
					setFunc = function(value) self.db.displayduration = value end,
					width = "half",
					default = LootDrop_Defaults.displayduration
					},
			[3] = {
					type = "slider",
					name = L.Width,
					tooltip = L.WidthTip,
					min = 100,
					max = 400,
					step = 1,
					getFunc = function() return self.db.width end,
					setFunc = function(value) self:ChangeWidth(value) end,
					width = "half",
					default = LootDrop_Defaults.width
					},
			[4] = {
					type = "slider",
					name = L.Height,
					tooltip = L.HeightTip,
					min = 25,
					max = 100,
					step = 1,
					getFunc = function() return self.db.height end,
					setFunc = function(value) self:ChangeHeight(value) end,
					width = "half",
					default = LootDrop_Defaults.height
					},
			[5] = {
					type = "slider",
					name = L.Padding,
					tooltip = L.PaddingTip,
					min = 0,
					max = 25,
					step = 1,
					getFunc = function() return self.db.padding end,
					setFunc = function(value) self:ChangePadding(value) end,
					width = "half",
					default = LootDrop_Defaults.padding
					},
			[6] = {
					type = "slider",
					name = L.MaxStacks,
					tooltip = L.MaxStacksTip,
					min = 1,
					max = 10,
					step = 1,
					getFunc = function() return self.db.maxstacks end,
					setFunc = function(value) self:ChangeMaxStacks(value) end,
					width = "half",
					default = LootDrop_Defaults.maxstacks
					},
			[7] = {
					type = "checkbox",
					name = L.StackUp,
					tooltip = L.StackUpTip,
					getFunc = function() return self.db.MoveUp end,
					setFunc = function(value) self:ToggleMoveUp(value) end,
					width = "full",
					default = LootDrop_Defaults.MoveUp
					},
			[8] = {
					type = "checkbox",
					name = L.RarityBorder,
					tooltip = L.RarityBorderTip,
					getFunc = function() return self.db.rarity end,
					setFunc = function(value) self:ToggleRarity(value) end,
					width = "full",
					default = LootDrop_Defaults.rarity
					},
			[9] = {
					type = "dropdown",
					name = L.Style,
					tooltip = L.StyleTip,
					choices = {LootDrop_sDefDefault, LootDrop_sDefPawkette, LootDrop_sDefRushmik, LootDrop_sDefESOclassic},
					getFunc = function() return self.db.sListStyle end,
					setFunc = function(valueString) self:PickStyle(valueString) end,
					width = "full",
					default = LootDrop_Defaults.sListStyle
					},
			[10] = {
					type = "slider",
					name = L.FontSize,
					tooltip = L.FontSizeTip,
					min = 10,
					max = 22,
					step = 1,
					getFunc = function() return self.db.FontSize end,
					setFunc = function(value) self:ChangeFontSize(value) end,
					width = "full",
					default = LootDrop_Defaults.FontSize
					},
			[11] = {
					type = "dropdown",
					name = L.BackgroundOverride,
					tooltip = L.BackgroundOverrideTip,
					choices = {"DEFAULT","/lootdrop/textures/flippedloothistorybg.dds", "/esoui/art/ava/ava_hud_bgframe.dds", "/esoui/art/progression/headerbg.dds", "/esoui/art/progression/list_header_bg.dds", "/esoui/art/contacts/social_list_bgstrip.dds", "/esoui/art/contacts/social_list_bgstrip_highlight.dds", "/esoui/art/voip/gamepad/gp_voip_namebg.dds", "/esoui/art/tradewindow/trade_itembg_left.dds", "/esoui/art/unitframes/unitframe_player.dds", "/lootdrop/textures/rushmik_bg.dds", "/lootdrop/textures/default_bg.dds", "/lootdrop/textures/ava_hud_bgframe_black.dds", "/lootdrop/textures/ava_hud_bgframe_grey.dds", "/lootdrop/textures/ava_hud_bgframe_white.dds",},
					getFunc = function() return self.db.LootDrop_sCustomBgTexture end,
					setFunc = function(valueString) self:SetCustomBgTexture(valueString) end, 
					width = "full",
					default = LootDrop_Defaults.LootDrop_sCustomBgTexture
					},
			[12] = {
					type = "header",
					name = L.ChatAppearance,
					},
			[13] = {
					type = "checkbox",
					name = L.LogTimeStamp,
					tooltip = L.LogTimeStampTip,
					getFunc = function() return self.db.DbgLogTime end,
					setFunc = function(value) self:ToggleDbgLogTime(value) end,
					width = "full",
					disabled = function() return (not self.db.DbgLogMine and not self.db.DbgLogOthers) end,
					default = LootDrop_Defaults.DbgLogTime
					},
			[14] = {
					type = "checkbox",
					name = L.LogItemStyle,
					tooltip = L.LogItemStyleTip,
					getFunc = function() return self.db.DbgLogItemStyle end,
					setFunc = function(value) self:ToggleDbgLogItemStyle(value) end,
					width = "full",
					disabled = function() return (not self.db.DbgLogMine and not self.db.DbgLogOthers) end,
					default = LootDrop_Defaults.DbgLogItemStyle
					},
			[15] = {
					type = "checkbox",
					name = L.LogItemTrait,
					tooltip = L.LogItemTraitTip,
					getFunc = function() return self.db.DbgLogItemTrait end,
					setFunc = function(value) self:ToggleDbgLogItemTrait(value) end,
					width = "full",
					disabled = function() return (not self.db.DbgLogMine and not self.db.DbgLogOthers) end,
					default = LootDrop_Defaults.DbgLogItemTrait
					},
			[16] = {
					type = "checkbox",
					name = L.LogItemValue,
					tooltip = L.LogItemValueTip,
					getFunc = function() return self.db.DbgLogItemValue end,
					setFunc = function(value) self:ToggleDbgLogItemValue(value) end,
					width = "full",
					disabled = function() return (not self.db.DbgLogMine and not self.db.DbgLogOthers) end,
					default = LootDrop_Defaults.DbgLogItemValue
					},
			[17] = {
					type = "checkbox",
					name = L.LogTag,
					tooltip = L.LogTagTip,
					getFunc = function() return self.db.DbgLogTag end,
					setFunc = function(value) self:ToggleDbgLogTag(value) end,
					width = "full",
					disabled = function() return (not self.db.DbgLogMine and not self.db.DbgLogOthers) end,
					default = LootDrop_Defaults.DbgLogTag
					},
				},
			},
		------------VALUE DISPLAY--------------
		{
			type = 'submenu',
			name = L.ValueeHeader,
			tooltip = '',
			controls = {
			[1] = {
					type = "dropdown",
					name = L.ValueLoot,
					tooltip = L.ValueLootTip,
					choices = {LootDrop_sListBoxValueNo, LootDrop_sListBoxValueVendor, LootDrop_sListBoxValueTrade, LootDrop_sListBoxValueVaT},
					getFunc = function() 
						local values = {[0] = LootDrop_sListBoxValueNo, [1] = LootDrop_sListBoxValueVendor, [2] = LootDrop_sListBoxValueTrade, [3] = LootDrop_sListBoxValueVaT}
						local opt = self.db.valueloot
						if opt ~= 0 and opt ~= 1 and opt ~=2 and opt ~= 3 then opt = 0 end
						return values[opt]
					end,
					setFunc = function(valueString)
						local values = {[LootDrop_sListBoxValueNo] = 0, [LootDrop_sListBoxValueVendor] = 1, [LootDrop_sListBoxValueTrade] = 2, [LootDrop_sListBoxValueVaT] = 3}
						self.db.valueloot = values[valueString] 
					end,
					width = "full",
					default = LootDrop_Defaults.valueloot
					},
			[2] = {
					type = "checkbox",
					name = L.StackVal,
					tooltip = L.StackValTip,
					getFunc = function() return self.db.stackval end,
					setFunc = function(value) self.db.stackval = value end,
					width = "full",
					disabled = function() return self.db.valueloot == 0 end,
					default = LootDrop_Defaults.stackval
					},
			[3] = {
					type = "checkbox",
					name = L.NoData,
					tooltip = L.NoDataTip,
					getFunc = function() return self.db.nodata end,
					setFunc = function(value) self.db.nodata = value end,
					width = "full",
					disabled = function() return self.db.valueloot == 0 end,
					default = LootDrop_Defaults.nodata
					},
			[4] = {
					type = "slider",
					name = L.ValueRound,
					tooltip = L.ValueRoundTip,
					min = 0,
					max = 4,
					step = 1,
					getFunc = function() return self.db.valueround end,
					setFunc = function(value) self.db.valueround = value end,
					width = "full",
					disabled = function() return self.db.valueloot == 0 end,
					default = LootDrop_Defaults.valueround
					},
				},
			},
		------------LOCK/UNLOCK--------------
		{
			type = "header",
			name = L.LockUnlockHeader,
			width = "full",
		},
		{
			type = "description",
			--title = "My Title",
			title = nil,
			text = L.LockUnlockTip,
			width = "full",
		},
		{
			type = "button",
			name = L.LockUnlockButton,
			tooltip = L.LockUnlockButtonTip,
			func = function() self:ToggleLock() end,
			width = "half",
		},
	}

	LAM2:RegisterOptionControls(ADDON_NAME, optionsTable)

end
------------GENERAL--------------
function LootDropConfig:ToggleLoot(value)
    self.db.loot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
----------------------------------
function LootDropConfig:ToggleLootHistory(value)
    self.db.loothistory = value
	if self.db.loothistory == true then 
	    SetSetting(SETTING_TYPE_LOOT, LOOT_SETTING_LOOT_HISTORY, 1)
	else 
	    SetSetting(SETTING_TYPE_LOOT, LOOT_SETTING_LOOT_HISTORY, 0)
    end 
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleMailLoot(value)
    self.db.mailloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_MAIL_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleCoin(valueString)
    self.db.coin = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_COIN )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleXP(valueString)
    self.db.experience = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleAP(valueString)
    self.db.alliance = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_AP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleTV(valueString)
    self.db.telvar = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_TV )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleWVoucher(valueString)
    self.db.wvoucher = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_WVOUCHER )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleUndaunted(valueString)
    self.db.undaunted = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_UNDAUNTED )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleTransmute(valueString)
    self.db.transmute = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_TRANSMUTE )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleETicket(valueString)
    self.db.eticket = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_ETICKET )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleEndeavor(valueString)
    self.db.endeavour = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_ENDEAVOR )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleCompanionXP(valueString)
    self.db.companionXP = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_COMPANION_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleCompanionRapport(valueString)
    self.db.companionRapport = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_COMPANION_RP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleNameLoot(value)
    self.db.nameloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleStackLoot(value)
    self.db.stackloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleStyleLoot(value)
    self.db.styleloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleJunk(value)
	self.db.Junk = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_JUNK )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleHideGUI(value)
	self.db.DbgHideGUI = value
	if (self.db.DbgHideGUI) then
		LootDropGui:SetHidden(true)
	else
		LootDropGui:SetHidden(false)
	end
	CBM:FireCallbacks( self.EVENT_TOGGLE_HIDEGUI )
end
--------------------------------------------------------------------------------
function LootDropConfig:ToggleHideMeters(value)
	self.db.HideMeters = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_HIDEMETERS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleLock() 
	self.db.lootdrop_lock = not self.db.lootdrop_lock
	CBM:FireCallbacks( self.EVENT_TOGGLE_LOCK )
end
-------------------------------------------------------------------------------
------------SKILL TREE XP--------------
function LootDropConfig:ToggleSkillXP(value)
	self.db.Skills = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleCraftXP(value)
	self.db.Craft = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleFenceXP(value)
	self.db.Fence = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleBookXP(value)
	self.db.Books = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleGuildXP(value)
	self.db.Guilds = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleWeapon(value)
	self.db.Weapon = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleArmor(value)
	self.db.Armor = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleWorld(value)
	self.db.World = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleAvA(value)
	self.db.AvA = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL )
end
-------------------------------------------------------------------------------
------------CHAT LOG--------------
function LootDropConfig:ToggleDbgLog(value)
	self.db.DbgLogMine = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleOthersLog(value)
	self.db.DbgLogOthers = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleGroupName(value)
    self.db.lootdrop_gname = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_GROUP_NAME )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogTime(value)
	self.db.DbgLogTime = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogItemStyle(value)
	self.db.DbgLogItemStyle = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogItemTrait(value)
	self.db.DbgLogItemTrait = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogItemValue(value)
	self.db.DbgLogItemValue = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogTag(value)
	self.db.DbgLogTag = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogGold(value)
	self.db.DbgLogGold = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogXP(value)
	self.db.DbgLogXP = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogAP(value)
	self.db.DbgLogAP = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogTelvar(value)
	self.db.DbgLogTelvar = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogWritVoucher(value)
	self.db.DbgLogWritVoucher = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogUndauntedKey(value)
	self.db.DbgLogUndauntedKey = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogTransmuteCrystal(value)
	self.db.DbgLogTransmuteCrystal = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogEventTicket(value)
	self.db.DbgLogEventTicket = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogEndeavor(value)
	self.db.DbgLogEndeavor = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogCXp(value)
	self.db.DbgLogCXp = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogRapport(value)
	self.db.DbgLogCRpt = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogCraftXP(value)
	self.db.DbgLogCraftXP = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogFenceXP(value)
	self.db.DbgLogFenceXP = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogBookKnowledge(value)
	self.db.DbgLogBookKnowledge = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogGuildRep(value)
	self.db.DbgLogGuildRep = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogWeapon(value)
	self.db.DbgLogWeapon = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogArmor(value)
	self.db.DbgLogArmor = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogWorld(value)
	self.db.DbgLogWorld = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogAvA(value)
	self.db.DbgLogAvA = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
------------DIM & STYLE--------------
function LootDropConfig:ChangeWidth(width)
	self.db.width = width
	CBM:FireCallbacks( self.EVENT_CHANGE_DIMENSIONS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangeHeight(height)
	self.db.height = height
	CBM:FireCallbacks( self.EVENT_CHANGE_DIMENSIONS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangeMaxStacks(maxstacks)
	self.db.maxstacks = maxstacks
	CBM:FireCallbacks( self.EVENT_CHANGE_DIMENSIONS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangePadding(padding)
	self.db.padding = padding
	CBM:FireCallbacks( self.EVENT_CHANGE_DIMENSIONS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleMoveUp(value) 
	self.db.MoveUp = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_MOVEUP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleRarity(value) 
	self.db.rarity = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_RARITY )
end
-------------------------------------------------------------------------------
function LootDropConfig:PickStyle(sValue)
   self.db.sListStyle = sValue
   CBM:FireCallbacks( self.EVENT_TOGGLE_STYLE )
end
-------------------------------------------------------------------------------
function LootDropConfig:SetCustomBgTexture(sValue)
   self.db.LootDrop_sCustomBgTexture = sValue
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangeFontSize(sValue)
   self.db.FontSize = sValue
   CBM:FireCallbacks( self.EVENT_TOGGLE_STYLE )
end
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- Called by bindings
function LootDrop_LockUnlock() -- objects & config cannot be called because of protection by the local vars, so using the global ref to access them.
	LOOTDROP_DB.Default[GetDisplayName()]["$AccountWide"].lootdrop_lock = not LOOTDROP_DB.Default[GetDisplayName()]["$AccountWide"].lootdrop_lock
	CBM:FireCallbacks( LootDropConfig.EVENT_TOGGLE_LOCK )
end
-------------------------------------------------------------------------------
function LootDrop_ToggleAutoloot()

	local Setting = GetSetting(SETTING_TYPE_LOOT, LOOT_SETTING_AUTO_LOOT)
	local Autolootinfo = ""

	if LOOTDROP_DB.Default[GetDisplayName()]["$AccountWide"].DbgLogTime then
		Autolootinfo = "[" .. GetTimeString() .. "]:"
	end
	
	if (Setting == "1") then
		Setting = "0"
		CHAT_SYSTEM:AddMessage(Autolootinfo .. L.AutoLootOff)
	else
		Setting = "1"
		CHAT_SYSTEM:AddMessage(Autolootinfo .. L.AutoLootOn)
	end

	SetSetting(SETTING_TYPE_LOOT, LOOT_SETTING_AUTO_LOOT, Setting, 1)
	
end
-------------------------------------------------------------------------------
function LootDrop_ToggleLootWindow()
	LOOTDROP_DB.Default[GetDisplayName()]["$AccountWide"].DbgHideGUI = not LOOTDROP_DB.Default[GetDisplayName()]["$AccountWide"].DbgHideGUI
	if (LOOTDROP_DB.Default[GetDisplayName()]["$AccountWide"].DbgHideGUI) then
		LootDropGui:SetHidden(true)
	else
		LootDropGui:SetHidden(false)
	end
	CBM:FireCallbacks( LootDropConfig.EVENT_TOGGLE_HIDEGUI )
end
-------------------------------------------------------------------------------

--LootDroppable----------------------------------------------------------------
local LootDroppable           = ZO_Object:Subclass()
-------------------------------------------------------------------------------
--- Create a new instance of a LootDroppable
-- @treturn LootDroppable
function LootDroppable:New( ... )
	local result = ZO_Object.New( self )
	result:Initialize( ... )
	return result
end
-------------------------------------------------------------------------------
--- Constructor
--
function LootDroppable:Initialize( objectPool )
	self.pool    = objectPool
	self.db      = objectPool.db
	self.control = CreateControlFromVirtual( 'LootDroppable', objectPool:GetControl(), 'LootDroppable', objectPool:GetNextId() )
	self.label   = self.control:GetNamedChild( '_Name' )
	self.icon    = self.control:GetNamedChild( '_Icon' )
	self.border  = self.control:GetNamedChild( '_Rarity' )
	self.bg      = self.control:GetNamedChild( '_BG' )
end
-------------------------------------------------------------------------------
--- Visibility Getter
-- @treturn boolean
function LootDroppable:IsVisible()
	return self.control:GetAlpha() > 0
end
-------------------------------------------------------------------------------
--- Show this droppable
-- @tparam number y
function LootDroppable:Show( x, y )
	self.enter_animation:Play()
	local current_x, current_y = self:GetOffsets()
	self.move_animation = self.pool._slide:Apply( self.control, current_x, current_y, x, y )
	self.move_animation:Play()
end
-------------------------------------------------------------------------------
function LootDroppable:Hide()
	if ( self.exit_animation ) then
		self.exit_animation:InsertCallback( function( ... ) self:Reset() end, 200 )
		self.exit_animation:Play()
	else
		self.control:SetAlpha( 0.0 )
		self:Reset()
	end
end
-------------------------------------------------------------------------------
--- Ready this droppable to show
function LootDroppable:Prepare(StackUp)
	if (StackUp==nil) then StackUp=true end
	local xdim, ydim = self.pool:GetControl():GetDimensions()
	local StartHeight =( #self.pool._active + 1 ) * ( self.db.height + self.db.padding )

	--self:SetAnchor( BOTTOMRIGHT, self.pool:GetControl(), BOTTOMRIGHT, self.db.width, ( #self.pool._active - 1 ) * ( ( self.db.height + self.db.padding ) * -1 ) )
	if (StackUp) then
		self:SetAnchor( BOTTOMRIGHT, self.pool:GetControl(), BOTTOMRIGHT, 0, - StartHeight )
	else
		self:SetAnchor( BOTTOMRIGHT, self.pool:GetControl(), BOTTOMRIGHT, 0, StartHeight - ydim )
	end

	self.control:SetWidth( self.db.width )
	self.control:SetHeight( self.db.height )
	self.icon:SetWidth( self.db.height )
	self.icon:SetHeight( self.db.height )

	self.enter_animation = self.pool._fadeIn:Apply( self.control )
	self.exit_animation  = self.pool._fadeOut:Apply( self.control )
	self.move_animation  = nil

	self.control:SetAlpha( 0 )
	self.label:SetText( '' )
	self.icon:SetTexture( '' )
	self.bg:SetTexture( '' )
	self.border:SetTexture( '' )
	self.timestamp = 0
end
-------------------------------------------------------------------------------
--- Reset this droppable
function LootDroppable:Reset()
	self.enter_animation = nil
	self.exit_animation  = nil
	self.move_animation  = nil

	self.label:SetText( '' )
	self.icon:SetHidden( true )
	self.bg:SetHidden( true )
	self.border:SetHidden( true )
	self.timestamp = 0
end
-------------------------------------------------------------------------------
--- Control getter
-- @treturn table
function LootDroppable:GetControl()
	return self.control
end
-------------------------------------------------------------------------------
--- Set show timestamp
-- @tparam number stamp
function LootDroppable:SetTimestamp( stamp )
	self.timestamp = stamp
end
-------------------------------------------------------------------------------
--- Get show timestamp
-- @treturn number
function LootDroppable:GetTimestamp()
	return self.timestamp
end
-------------------------------------------------------------------------------
--- Set label
-- @tparam string label
function LootDroppable:SetLabel( label )
	self.label:SetText( label )
end
-------------------------------------------------------------------------------
--- Set label Size
-- @tparam number size
function LootDroppable:SetLabelSize( size )
	local size = size or 14
	local font='$(BOLD_FONT)|' .. size .. '|soft-shadow-thin'
	self.label:SetFont( font )
end
-------------------------------------------------------------------------------
function LootDroppable:SetBackground()
    if  self.db.LootDrop_sCustomBgTexture ~= nil and self.db.LootDrop_sCustomBgTexture ~= "DEFAULT" then
	    self.bg:SetTexture(self.db.LootDrop_sCustomBgTexture)
	else
	    self.bg:SetTexture(LootDrop_sBgTexture)
	end
	self.bg:SetHidden( false )
end
-------------------------------------------------------------------------------
--- Set rarity border
-- @tparam ZO_ColorDef color
function LootDroppable:SetRarity( color , b_rarity )

	if (b_rarity==nil) then 
		b_rarity=true
	end

	if (( not color ) and (b_rarity)) then
		color = ZO_ColorDef:New( 1, 1, 1, 1 )
	end

	if (not b_rarity) then
		color = ZO_ColorDef:New( 0, 0, 0, 0)
	end

	self.border:SetTexture(LootDrop_sRarityTexture)
	self.border:SetColor( color:UnpackRGBA() )
	self.border:SetHidden( false )
end
-------------------------------------------------------------------------------
function LootDroppable:GetLabel()
	return tonumber( self.label:GetText() or 0 )
end
-------------------------------------------------------------------------------
--- Set Icon
-- @tparam string icon
function LootDroppable:SetIcon( icon, coords )
	--local texture = self.icon:GetTextureInfo()
	local texture = self.icon:GetTextureFileName()

	if ( texture ~= icon ) then
		self.icon:SetTexture( icon )
	end

	if ( coords ) then
		self.icon:SetTextureCoords( unpack( coords ) )
	else
		self.icon:SetTextureCoords( 0, 1, 0, 1 )
	end

	self.icon:SetHidden( false )
end
-------------------------------------------------------------------------------
--- Pass anchor information to control
function LootDroppable:SetAnchor( ... )
	self.control:SetAnchor( ... )
end
-------------------------------------------------------------------------------
--- Pass translate information to animation
function LootDroppable:Move( x, y )
	local current_x, current_y = self:GetOffsets()
	self.move_animation = self.pool._slide:Apply( self.control, current_x, current_y, x, y )
	self.move_animation:Play()
end
-------------------------------------------------------------------------------
--- Get current y offset
-- @treturn number
function LootDroppable:GetOffsets()
	local _, _, _, _, offsX, offsY = self.control:GetAnchor( 0 )
	return offsX, offsY
end
-------------------------------------------------------------------------------


--LootDrop Object--------------------------------------------------------------
local LootDrop							= LootDropPool:Subclass()

LootDrop.dirty_flags					= setmetatable( {}, { __mode = 'kv'} )
LootDrop.config							= nil
LootDrop.db								= nil
LootDrop.ScreenMaxWidth					= 800
LootDrop.ScreenMaxHeight				= 600
LootDrop.CurrentItemBag_ItemStyle		= nil
LootDrop.CurrentItemBag_ItemType		= nil
LootDrop.CurrentItemBag_ItemLink		= nil
LootDrop.CurrentItemBag_ItemQuality		= nil
LootDrop.CurrentItemBag_ItemNb			= nil
LootDrop.ItemToPrint					= {iconFileName  = [[/esoui/art/icons/icon_missing.dds]], color='FFFFFF', quantity=0, nb=0, text='', tag='', itemstyle=nil}
LootDrop.MailStacks						= {}
LootDrop.loaded							= false
-------------------------------------------------------------------------------
--- Create our ObjectPool
-- @param ...
function LootDrop:New( ... )
	local result = LootDropPool.New( self )
	result:Initialize( ... )
	return result
end
-------------------------------------------------------------------------------
--- I swear I'm going to use this for something
-- @param ...
function LootDrop:Initialize( control )
	self.control = control
	self.control:RegisterForEvent( EVENT_ADD_ON_LOADED, function( ... ) self:OnLoaded( ... ) end )

	LootDropPool.Initialize( self, function() return self:CreateDroppable() end, function( ... ) self:ResetDroppable( ... ) end  )

	self.control:SetHandler( 'OnUpdate',			function( _, ft )		self:OnUpdate( ft )		end )
	self.control:SetHandler( 'OnMoveStop',			function( )				self:OnMoveStop( )		end )

	self._fadeIn  = LootDropFade:New( 0.0, 1.0, 200 )
	self._fadeOut = LootDropFade:New( 1.0, 0.0, 200 )
	self._slide   = LootDropSlide:New( 200 )
	self._pop     = LootDropPop:New()

	self._coinId						= nil
	self._coinLastVal					= 0

	self._xpId							= nil
	self._xpLastVal						= 0

	self._xpCompanionId					= nil
	self._xpCompanionLastVal			= 0

	self._rapportId						= nil
	self._rapportLastVal				= 0

	self._apId							= nil
	self._apLastVal						= 0
	
	self._rpId							= nil
	self._rpLastVal						= 0

	self._tvId							= nil
	self._tvLastVal						= 0

	self._wVoucherId					= nil
	self._wVoucherLastVal				= 0

	self._undauntedId					= nil
	self._undauntedLastVal				= 0

	self._transmuteId					= nil
	self._transmuteLastVal				= 0

	self._eticketId						= nil
	self._eticketLastVal				= 0

	self._skillXpId						= nil
	self._skillXpLastVal				= 0

	self._skillMageXpId					= nil
	self._skillMageXpLastVal			= 0

	self._skillFighterXpId				= nil
	self._skillFighterXpLastVal			= 0

	self._skillUndauntedXpId			= nil
	self._skillUndauntedXpLastVal		= 0

	self._skillPsijicXpId				= nil
	self._skillPsijicXpLastVal			= 0

	self._skillBookXpId					= nil

	self._skillFenceXpId				= nil
	self._skillFenceXpLastVal			= 0

	self._skillThievesXpId				= nil
	self._skillThievesXpLastVal			= 0

	self._skillBrotherhoodXpId			= nil
	self._skillBrotherhoodXpLastVal		= 0

---------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Skill Line Progress
---------------------------------------------------------------------------------------------------------------------------------------------------------------
	self._skillTableArmor = {
		[1] = {key = nil, val = 0, tag = "LIGHTARMOR",	icon = "esoui/art/icons/progression_tabicon_armorlight_up.dds"},			-- Light Armor
		[2] = {key = nil, val = 0, tag = "MEDIUMARMOR",	icon = "esoui/art/icons/progression_tabicon_armormedium_up.dds"},			-- Medium Armor
		[3] = {key = nil, val = 0, tag = "HEAVYARMOR",	icon = "esoui/art/icons/progression_tabicon_armorheavy_up.dds"},			-- Heavy Armor
	}
	self._skillTableAvA = {
		[1] = {key = nil, val = 0, tag = "ASSAULT",		icon = "esoui/art/compass/ava_largekeep_neutral.dds"},						-- Assault
		[2] = {key = nil, val = 0, tag = "EMPEROR",		icon = "esoui/art/campaign/gamepad/gp_overview_menuicon_emperor.dds"},		-- Emperor
		[3] = {key = nil, val = 0, tag = "SUPPORT",		icon = "esoui/art/compass/ava_outpost_neutral.dds"},						-- Support
	}
	self._skillTableWeapon = {
		[1] = {key = nil, val = 0, tag = "TWOHANDED",	icon = "esoui/art/icons/icon_2handed.dds"},									-- Two-Handed
		[2] = {key = nil, val = 0, tag = "1HSHIELD",	icon = "esoui/art/icons/icon_1handed.dds"},									-- 1-Hand & Shield
		[3] = {key = nil, val = 0, tag = "DUALWIELD",	icon = "esoui/art/icons/icon_dualwield.dds"},								-- Dual Wield
		[4] = {key = nil, val = 0, tag = "BOW",			icon = "esoui/art/icons/icon_bows.dds"},									-- Bow
		[5] = {key = nil, val = 0, tag = "DESTRUCTION",	icon = "esoui/art/icons/icon_firestaff.dds"},								-- Destruction Staff
		[6] = {key = nil, val = 0, tag = "RESTORATION",	icon = "esoui/art/icons/progression_tabicon_healstaff_up.dds"},				-- Restoration Staff
	}
	self._skillTableWorld = {
		[1] = {key = nil, val = 0, tag = "EXCAVATION",	icon = "esoui/art/icons/servicemappins/servicepin_antiquities.dds"},		-- Excavation
		[3] = {key = nil, val = 0, tag = "SCRYING",		icon = "esoui/art/icons/collectible_memento_psijicscryingtalisman.dds"},	-- Scrying
		[4] = {key = nil, val = 0, tag = "SOUL",		icon = "esoui/art/icons/soulgem_006_filled.dds"},							-- Soul Magic
		[5] = {key = nil, val = 0, tag = "VAMPIRE",		icon = "esoui/art/icons/ability_vampire_007.dds"},							-- Vampire
		[6] = {key = nil, val = 0, tag = "WEREWOLF",	icon = "esoui/art/icons/ability_werewolf_010.dds"},							-- Werewolf
	}

	self.lastRankXP, self.nextRankXP, self.currentXP = GetSkillLineXPInfo(skillType, skillLineIndex)
---------------------------------------------------------------------------------------------------------------------------------------------------------------
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_LOOT,			function() self:ToggleLoot()    			end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_MAIL_LOOT,	function() self:ToggleMailLoot()    		end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_GROUP_NAME,	function() self:ToggleGroupName()   		end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_COIN,			function() self:ToggleCoin()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_XP,			function() self:ToggleXP()      			end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_AP,			function() self:ToggleAP()					end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_TV,			function() self:ToggleTV()					end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_WVOUCHER,		function() self:ToggleWVoucher()			end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_UNDAUNTED,	function() self:ToggleUndaunted()			end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_TRANSMUTE,	function() self:ToggleTransmute()			end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_ETICKET,		function() self:ToggleETicket()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_ENDEAVOR,		function() self:ToggleEndeavor()			end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_COMPANION_XP,	function() self:ToggleCompanionXP()     	end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_COMPANION_RP,	function() self:ToggleCompanionRapport()	end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_SKILL_XP,		function() self:ToggleSkillXP()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_SKILL,		function() self:ToggleSkill()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_JUNK,			function() self:ToggleJunk()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_HIDEGUI,		function() self:ToggleHideGUI()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_HIDEMETERS,	function() self:ToggleHideMeters()			end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_DEBUGLOG,		function() self:ToggleDbgLog()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_STYLE,		function() self:ToggleStyle()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_LOCK,			function() self:ToggleLock()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_RARITY,		function() self:ToggleRarity()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_TOGGLE_MOVEUP,		function() self:ToggleMoveUp()				end )
	CBM:RegisterCallback( LootDropConfig.EVENT_CHANGE_DIMENSIONS,	function() self:ChangeDimensions()			end )
---------------------------------------------------------------------------------------------------------------------------------------------------------------

	local pChars = {
		["Dar'jazad"] = "Rajhin's Echo",
		["Quantus Gravitus"] = "Maker of Things",
		["Nina Romari"] = "Sanguine Coalescence",
		["Valyria Morvayn"] = "Dragon's Teeth",
		["Sanya Lightspear"] = "Thunderbird",
		["Divad Arbolas"] = "Gravity of Words",
		["Dro'samir"] = "Dark Matter",
		["Irae Aundae"] = "Prismatic Inversion",
		["Quixoti'coatl"] = "Time Toad",
		["Cythirea"] = "Mazken Stormclaw",
		["Fear-No-Pain"] = "Soul Sap",
		["Wax-in-Winter"] = "Cold Blooded",
		["Nateo Mythweaver"] = "In Strange Lands",
		["Cindari Atropa"] = "Dragon's Breath",
		["Kailyn Duskwhisper"] = "Nowhere's End",
		["Draven Blightborn"] = "From Outside",
		["Lorein Tarot"] = "Entanglement",
		["Koh-Ping"] = "Global Cooling",
	}

	local function modifyTitle(oTitle, uName)
		local tLang = {
			en = "Volunteer",
			fr = "Volontaire",
			de = "Freiwillige",
		}
		local client = GetCVar("Language.2")
		if oTitle == tLang[client] then
			return (pChars[uName] ~= nil) and pChars[uName] or oTitle
		end
		return oTitle
	end

	local modifyGetTitle = GetTitle
	GetTitle = function(index)
		local oTitle = modifyGetTitle(index)
		local uName = GetUnitName('player')
		local rTitle = modifyTitle(oTitle, uName)
		return rTitle
	end

	local modifyGetUnitTitle = GetUnitTitle
	GetUnitTitle = function(unitTag)
		local oTitle = modifyGetUnitTitle(unitTag)
		local uName = GetUnitName(unitTag)
		local rTitle = modifyTitle(oTitle, uName)
		return rTitle
	end
end
-------------------------------------------------------------------------------
function LootDrop:RunUpdates(current)
	if current < tonumber(ADDON_VERSION) then
		if self.db.version < 4.07 then -- switches previous boolean value to digit to avoid update errors
			if self.db.valueloot == true or self.db.valueloot == false then self.db.valueloot = 0 end
			self.db.version = 4.07
			zo_callLater(function() self:RunUpdates(4.07) end, 100)
			return
		elseif self.db.version < 4.23 then -- switch previous display variables to boolean
			self.db.Fence = true
			self.db.Books = true
			self.db.Guilds = true
			self.db.version = 4.23
			zo_callLater(function() self:RunUpdates(4.23) end, 100)
			return
		else
			self.db.version = tonumber(ADDON_VERSION)
		end
	end
end

function LootDrop:OnLoaded( event, addon )
	if ( addon ~= ADDON_NAME ) then
		return
	end
	

	
    self.control:UnregisterForEvent( EVENT_ADD_ON_LOADED )
	
	self.db     = ZO_SavedVars:NewAccountWide( 'LOOTDROP_DB', 3.0, nil, LootDrop_Defaults )
	self.config = LootDropConfig:New( self.db )

	-- if self.db.version < tonumber(ADDON_VERSION) then
		-- zo_callLater(function() self:RunUpdates(0) end, 2000) -- run necessary updates sequentially (Phinix)
	-- end

	self:ToggleLoot()
	self:ToggleMailLoot()
	self:ToggleGroupName()
	self:ToggleCoin()
	self:ToggleXP()
	self:ToggleAP()
	self:ToggleTV()
	self:ToggleWVoucher()
	self:ToggleUndaunted()
	self:ToggleTransmute()
	self:ToggleETicket()
	self:ToggleEndeavor()
	self:ToggleCompanionXP()
	self:ToggleCompanionRapport()
	self:ToggleSkillXP()
	self:ToggleStyle()

	-- update addon when companion is activated/dismissed
	self.control:RegisterForEvent( EVENT_COMPANION_ACTIVATED, function() self:ToggleCompanionXP() self:ToggleCompanionRapport() end )
	self.control:RegisterForEvent( EVENT_COMPANION_DEACTIVATED, function() self:ToggleCompanionXP() self:ToggleCompanionRapport() end )

	local leftScreen, topScreen, rightScreen, bottomScreen  = GuiRoot:GetScreenRect()
	self.ScreenMaxWidth = rightScreen
	self.ScreenMaxHeight = bottomScreen

	self.control:ClearAnchors()
	self.control:SetAnchor(BOTTOMRIGHT, GuiRoot, BOTTOMRIGHT, self.db.lootdrop_x, self.db.lootdrop_y)
	local x = zo_min((self.ScreenMaxWidth-50),(self.db.width+1))
	local y = zo_min((self.ScreenMaxHeight-50),11*(self.db.height + self.db.padding))
	self.control:SetDimensions(x, y)
	self.control:SetDrawLayer(0)
	self.control:SetMovable(not self.db.lootdrop_lock)
	self.control:SetMouseEnabled(not self.db.lootdrop_lock)

	local MoveBG = WINDOW_MANAGER:CreateControl( "LootDropMoveMeBg",  self.control, CT_BACKDROP)  
	LootDropMoveMeBg:SetHidden(self.db.lootdrop_lock)
	LootDropMoveMeBg:SetAnchor(BOTTOMRIGHT, self.control, BOTTOMRIGHT, 0, 0)
	LootDropMoveMeBg:SetAnchorFill(self.control)
	LootDropMoveMeBg:SetCenterColor( 0,0,0,0.4 )
	LootDropMoveMeBg:SetCenterTexture("",8,1,2)
	LootDropMoveMeBg:SetEdgeColor( 0,0,0,0 )
	LootDropMoveMeBg:SetEdgeTexture("",8,1,2)

	-- maintain the hidden state of the LootDrop GUI
	if (self.db.DbgHideGUI) then LootDropGui:SetHidden(true) else LootDropGui:SetHidden(false) end

	self.loaded = true
	zo_callLater(self.start, 10000)

end

function LootDrop.start()
CHAT_SYSTEM:AddMessage("|cFF0000Lootdrop Deluxe is deprecated:|r |cFFFFFFPhinix is back and has updated Lootdrop Reborn|r |c9DFE00 Delete your Lootdrop folder and install Lootdrop Reborn now.|r |cC3C09CSee ya! Masteroshi430.|r")

end
-------------------------------------------------------------------------------
function LootDrop:ChangeDimensions()
	self.control:SetDimensions(zo_min((self.ScreenMaxWidth-50),(self.db.width+1)), zo_min((self.ScreenMaxHeight-50),11*(self.db.height + self.db.padding)))
end
-------------------------------------------------------------------------------
function LootDrop:ToggleMoveUp()
	--nothing to do, function just in case ... ;-)
	self.db.MoveUp = self.db.MoveUp	
end
-------------------------------------------------------------------------------
function LootDrop:ToggleRarity()
	--nothing to do, function just in case ... ;-)
	self.db.rarity = self.db.rarity
end
-------------------------------------------------------------------------------
function LootDrop:ToggleJunk()
	--nothing to do, function just in case ... ;-)
	self.db.Junk = self.db.Junk
end
-------------------------------------------------------------------------------
function LootDrop:ToggleHideGUI()
	--nothing to do, function just in case ... ;-)
	self.db.DbgHideGUI = self.db.DbgHideGUI
end
-------------------------------------------------------------------------------
function LootDrop:ToggleDbgLog()
	--nothing to do, function just in case ... ;-)
	self.db.DbgLogMine				= self.db.DbgLogMine
	self.db.DbgLogOthers    		= self.db.DbgLogOthers
	self.db.DbgLogGold      		= self.db.DbgLogGold
	self.db.DbgLogXP        		= self.db.DbgLogXP
	self.db.DbgLogAP        		= self.db.DbgLogAP
	self.db.DbgLogTelvar			= self.db.DbgLogTelvar
	self.db.DbgLogWritVoucher		= self.db.DbgLogWritVoucher
	self.db.DbgLogUndauntedKey		= self.db.DbgLogUndauntedKey
	self.db.DbgLogTransmuteCrystal	= self.db.DbgLogTransmuteCrystal
	self.db.DbgLogEventTicket		= self.db.DbgLogEventTicket
	self.db.DbgLogEndeavor		    = self.db.DbgLogEndeavor	
	self.db.DbgLogCXp				= self.db.DbgLogCXp
	self.db.DbgLogCRpt				= self.db.DbgLogCRpt
	self.db.DbgLogCraftXP			= self.db.DbgLogCraftXP
	self.db.DbgLogFenceXP			= self.db.DbgLogFenceXP
	self.db.DbgLogBookKnowledge		= self.db.DbgLogBookKnowledge
	self.db.DbgLogGuildRep			= self.db.DbgLogGuildRep
	self.db.DbgLogWeapon			= self.db.DbgLogWeapon
	self.db.DbgLogArmor				= self.db.DbgLogArmor
	self.db.DbgLogWorld				= self.db.DbgLogWorld
	self.db.DbgLogAvA				= self.db.DbgLogAvA
	self.db.DbgLogTag       		= self.db.DbgLogTag
	self.db.DbgLogTime      		= self.db.DbgLogTime
	self.db.DbgLogItemStyle 		= self.db.DbgLogItemStyle
	self.db.DbgLogItemTrait 		= self.db.DbgLogItemTrait
end
-------------------------------------------------------------------------------
function LootDrop:ToggleStyle()
	if (self.db.sListStyle == LootDrop_sDefRushmik) then						--Rushmik
		LootDrop_sApIcon        	= [[/lootdrop/textures/ap_rushmik_up.dds]]
		LootDrop_sXpIcon        	= [[/lootdrop/textures/xp_rushmik_up.dds]]
		LootDrop_sRapportUpIcon		= [[/lootdrop/textures/rapport_rushmik_up.dds]]
		LootDrop_sRapportDownIcon	= [[/lootdrop/textures/rapport_rushmik_down.dds]]
		LootDrop_sSkillXpIcon   	= [[/lootdrop/textures/skill_rushmik_up.dds]]
		LootDrop_sBgTexture     	= [[/lootdrop/textures/rushmik_bg.dds]]
		LootDrop_sRarityTexture 	= [[/lootdrop/textures/rushmik_rarity.dds]]
	elseif (self.db.sListStyle == LootDrop_sDefPawkette) then					--Pawkette
		LootDrop_sApIcon        	= [[/lootdrop/textures/ap_pawkette_up.dds]]
		LootDrop_sXpIcon        	= [[/lootdrop/textures/xp_pawkette_up.dds]]
		LootDrop_sRapportUpIcon		= [[/lootdrop/textures/rapport_up.dds]]
		LootDrop_sRapportDownIcon	= [[/lootdrop/textures/rapport_down.dds]]
		LootDrop_sSkillXpIcon   	= [[/lootdrop/textures/skill_pawkette_up.dds]]
		LootDrop_sBgTexture     	= [[/lootdrop/textures/default_bg.dds]]
		LootDrop_sRarityTexture 	= [[/lootdrop/textures/default_rarity.dds]]
	elseif (self.db.sListStyle == LootDrop_sDefESOclassic) then					--ESOclassic by @Masteroshi430
		LootDrop_sApIcon        	= [[/esoui/art/icons/icon_alliancepoints.dds]]
		LootDrop_sXpIcon        	= [[/EsoUI/Art/Icons/Icon_Experience.dds]]
		LootDrop_sRapportUpIcon		= [[/EsoUI/Art/HUD/lootHistory_icon_rapportIncrease.dds]]
		LootDrop_sRapportDownIcon	= [[/EsoUI/Art/HUD/lootHistory_icon_rapportDecrease.dds]]
		LootDrop_sSkillXpIcon   	= [[/esoui/art/progression/progression_tabicon_combatskills_up.dds]]
		LootDrop_sBgTexture     	= [[/lootdrop/textures/ava_hud_bgframe_black.dds]]
		LootDrop_sRarityTexture 	= [[/lootdrop/textures/default_rarity.dds]]
	else																		--Default
		LootDrop_sApIcon        	= [[/lootdrop/textures/ap_up.dds]]
		LootDrop_sXpIcon        	= [[/lootdrop/textures/xp_up.dds]]
		LootDrop_sRapportUpIcon		= [[/lootdrop/textures/rapport_up.dds]]
		LootDrop_sRapportDownIcon	= [[/lootdrop/textures/rapport_down.dds]]
		LootDrop_sSkillXpIcon   	= [[/lootdrop/textures/skill_up.dds]]
		LootDrop_sBgTexture     	= [[/lootdrop/textures/default_bg.dds]]
		LootDrop_sRarityTexture 	= [[/lootdrop/textures/default_rarity.dds]]
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleLock()

	self.control:SetMovable(not self.db.lootdrop_lock)
	self.control:SetMouseEnabled(not self.db.lootdrop_lock)
	LootDropMoveMeBg:SetHidden(self.db.lootdrop_lock)

	if (self.db.lootdrop_lock) then
		local leftScreen, topScreen, rightScreen, bottomScreen  = GuiRoot:GetScreenRect()
		local left, top, right, bottom = self.control:GetScreenRect()

		self.db.lootdrop_x = math.floor(right - rightScreen)
		self.db.lootdrop_y = math.floor(bottom - bottomScreen)
	end
end
-------------------------------------------------------------------------------
function LootDrop:AccountCurrencies()
	local undaunted = ((self.db.undaunted ~= LootDrop_sListBoxNo) or (self.db.DbgLogUndauntedKey))
	local transmute = ((self.db.transmute ~= LootDrop_sListBoxNo) or (self.db.DbgLogTransmuteCrystal))
	local eticket = ((self.db.eticket ~= LootDrop_sListBoxNo) or (self.db.DbgLogEventTicket))
	local endeavor = ((self.db.Endeavor ~= LootDrop_sListBoxNo) or (self.db.DbgLogEndeavor))

-- register EVENT_CURRENCY_UPDATE if any currency that needs it is enabled
	if ( undaunted ) or ( transmute ) or ( eticket ) or ( endeavor ) then
		self.control:RegisterForEvent( EVENT_CURRENCY_UPDATE, function( _, ... ) self:OnCurrencyUpdate( ... ) end )
	else
		self.control:UnregisterForEvent( EVENT_CURRENCY_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleLoot()
	if ( self.db.loot ) then
		self.control:RegisterForEvent( EVENT_LOOT_RECEIVED,function( _, ... )  self:OnLootReceived( ... )    end )
	-- Pre-filter heavy events where possible to improve performance: https://wiki.esoui.com/AddFilterForEvent (Phinix)
		EVENT_MANAGER:RegisterForEvent('LootDrop_Filter_Bag1', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, function( ... ) self:OnSingleSlotUpdate( ... )    end)
		EVENT_MANAGER:AddFilterForEvent('LootDrop_Filter_Bag1', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_BACKPACK)
		EVENT_MANAGER:RegisterForEvent('LootDrop_Filter_Bag2', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, function( ... ) self:OnSingleSlotUpdate( ... )    end)
		EVENT_MANAGER:AddFilterForEvent('LootDrop_Filter_Bag2', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_VIRTUAL)
		EVENT_MANAGER:RegisterForEvent('LootDrop_Filter_Reason', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, function( ... ) self:OnSingleSlotUpdate( ... )    end)
		EVENT_MANAGER:AddFilterForEvent('LootDrop_Filter_Reason', EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_DEFAULT)

	else
		self.control:UnregisterForEvent( EVENT_LOOT_RECEIVED )
		EVENT_MANAGER:UnregisterForEvent('LootDrop_Filter_Bag1', EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
		EVENT_MANAGER:UnregisterForEvent('LootDrop_Filter_Bag2', EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
		EVENT_MANAGER:UnregisterForEvent('LootDrop_Filter_Reason', EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleMailLoot()
	if ( self.db.mailloot ) and ( self.db.loot )then
		self.control:RegisterForEvent( EVENT_MAIL_TAKE_ATTACHED_ITEM_SUCCESS, function( _, ... ) self:OnMailItemLooted( ... )    end )
		self.control:RegisterForEvent( EVENT_MAIL_READABLE, function( _, ... ) self:OnMailReadable( ... )    end )
	else
		self.control:UnregisterForEvent( EVENT_MAIL_TAKE_ATTACHED_ITEM_SUCCESS )
		self.control:UnregisterForEvent( EVENT_MAIL_READABLE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleGroupName()
	LootDrop.GroupNames = {}
	if (self.db.DbgLogOthers) and self.db.lootdrop_gname ~= 0 then
		self.control:RegisterForEvent( EVENT_GROUP_TYPE_CHANGED, function( _, ... ) self:OnGroupChanged( ... ) end )
		self.control:RegisterForEvent( EVENT_GROUP_MEMBER_JOINED, function( _, ... ) self:OnGroupChanged( ... ) end )
		self.control:RegisterForEvent( EVENT_GROUP_MEMBER_LEFT, function( _, ... ) self:OnGroupChanged( ... ) end )
		self.control:RegisterForEvent( EVENT_GROUP_UPDATE, function( _, ... ) self:OnGroupChanged( ... ) end )
		self:OnGroupChanged()
	else
		self.control:UnregisterForEvent( EVENT_GROUP_TYPE_CHANGED )
		self.control:UnregisterForEvent( EVENT_GROUP_MEMBER_JOINED )
		self.control:UnregisterForEvent( EVENT_GROUP_MEMBER_LEFT )
		self.control:UnregisterForEvent( EVENT_GROUP_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleCoin()
	if ((self.db.coin ~= LootDrop_sListBoxNo) or (self.db.DbgLogGold)) then
		self.control:RegisterForEvent( EVENT_MONEY_UPDATE, function( _, ... ) self:OnMoneyUpdated( ... )  end )
	else
		self.control:UnregisterForEvent( EVENT_MONEY_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleXP()
	if ((self.db.experience ~= LootDrop_sListBoxNo) or (self.db.DbgLogXP)) then
		self.control:RegisterForEvent( EVENT_EXPERIENCE_GAIN, function( _, ... ) self:OnXPUpdated( ... )     end )
	else
		self.control:UnregisterForEvent( EVENT_EXPERIENCE_GAIN )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleAP()
	if ((self.db.alliance ~= LootDrop_sListBoxNo) or (self.db.DbgLogAP)) then
		local function GetCurrentRankProgress()
			local rankPoints = GetUnitAvARankPoints("player")
			local _, _, rankStartsAt, nextRankAt = GetAvARankProgress(rankPoints)
			return rankPoints - rankStartsAt
		end
		local rankPoints = GetCurrentRankProgress()
		self.current_ap = GetCurrencyAmount(CURT_ALLIANCE_POINTS, CURRENCY_LOCATION_CHARACTER)
		self.current_rp = rankPoints
		self.control:RegisterForEvent( EVENT_ALLIANCE_POINT_UPDATE, function( _, ... ) self:OnAPUpdate( ... ) end )
	else
        self.control:UnregisterForEvent( EVENT_ALLIANCE_POINT_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleTV()
	if ((self.db.telvar ~= LootDrop_sListBoxNo) or (self.db.DbgLogTelvar)) then
		self.current_telvar = GetCurrencyAmount(CURT_TELVAR_STONES, CURRENCY_LOCATION_CHARACTER)
		self.control:RegisterForEvent( EVENT_TELVAR_STONE_UPDATE, function( _, ... ) self:OnTVUpdate( ... ) end )
	else
		self.control:UnregisterForEvent( EVENT_TELVAR_STONE_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleWVoucher()
	if ((self.db.wvoucher ~= LootDrop_sListBoxNo) or (self.db.DbgLogWritVoucher)) then
		self.current_writv = GetCurrencyAmount(CURT_WRIT_VOUCHERS, CURRENCY_LOCATION_CHARACTER)
		self.control:RegisterForEvent( EVENT_WRIT_VOUCHER_UPDATE, function( _, ... ) self:OnWVoucherUpdate( ... ) end )
	else
		self.control:UnregisterForEvent( EVENT_WRIT_VOUCHER_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleUndaunted()
	if ((self.db.undaunted ~= LootDrop_sListBoxNo) or (self.db.DbgLogUndauntedKey)) then
		self.current_undaunted = GetCurrencyAmount(CURT_UNDAUNTED_KEYS, CURRENCY_LOCATION_ACCOUNT)
	end
	self:AccountCurrencies()
end
-------------------------------------------------------------------------------
function LootDrop:ToggleTransmute()
	if ((self.db.transmute ~= LootDrop_sListBoxNo) or (self.db.DbgLogTransmuteCrystal)) then
		self.current_transmute = GetCurrencyAmount(CURT_CHAOTIC_CREATIA, CURRENCY_LOCATION_ACCOUNT)
	end
	self:AccountCurrencies()
end
-------------------------------------------------------------------------------
function LootDrop:ToggleETicket()
	if ((self.db.eticket ~= LootDrop_sListBoxNo) or (self.db.DbgLogEventTicket)) then
		self.current_eticket = GetCurrencyAmount(CURT_EVENT_TICKETS, CURRENCY_LOCATION_ACCOUNT)
	end
	self:AccountCurrencies()
end
-------------------------------------------------------------------------------
function LootDrop:ToggleEndeavor()
	if ((self.db.Endeavor ~= LootDrop_sListBoxNo) or (self.db.DbgLogEndeavor)) then
		self.current_Endeavor = GetCurrencyAmount(CURT_ENDEAVOR_SEALS, CURRENCY_LOCATION_ACCOUNT)
	end
	self:AccountCurrencies()
end
-------------------------------------------------------------------------------
function LootDrop:ToggleCompanionXP()
	if ((self.db.companionXP ~= LootDrop_sListBoxNo) or (self.db.DbgLogCXp)) and (HasActiveCompanion()) then
		self.control:RegisterForEvent(EVENT_COMPANION_EXPERIENCE_GAIN, function(_, ... ) self:CompanionXPUpdate(...) end )
	else
		self.control:UnregisterForEvent( EVENT_COMPANION_EXPERIENCE_GAIN )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleCompanionRapport()
	if ((self.db.companionRapport ~= LootDrop_sListBoxNo) or (self.db.DbgLogCRpt)) and (HasActiveCompanion()) then
		self.control:RegisterForEvent(EVENT_COMPANION_RAPPORT_UPDATE, function(_, ... ) self:CompanionRapportUpdate(...) end )
	else
		self.control:UnregisterForEvent( EVENT_COMPANION_RAPPORT_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleSkillXP()
	local lootSkills = ((self.db.DbgLogCraftXP) or (self.db.DbgLogFenceXP) or (self.db.DbgLogBookKnowledge) or (self.db.DbgLogGuildRep) or (self.db.DbgLogWeapon) or (self.db.DbgLogArmor) or (self.db.DbgLogWorld) or (self.db.DbgLogAvA))
	local chatSkills = ((self.db.Craft) or (self.db.Fence) or (self.db.Books) or (self.db.Guilds) or (self.db.Weapon) or (self.db.Armor) or (self.db.World) or (self.db.AvA))

	if (((self.db.Skills ~= LootDrop_sListBoxNo) and (lootSkills)) or (chatSkills)) then
		self.control:RegisterForEvent( EVENT_SKILL_XP_UPDATE, function( ... ) self:OnSkillXPUpdated( ... )     end )
	else
		self.control:UnregisterForEvent( EVENT_SKILL_XP_UPDATE )
	end
end
-------------------------------------------------------------------------------
function LootDrop:ToggleSkill()
	if self.db.Skills ~= LootDrop_sListBoxNo then
		if ((not self.db.Craft) and (not self.db.Fence) and (not self.db.Books) and (not self.db.Guilds) and (not self.db.Weapon) and (not self.db.Armor) and (not self.db.World) and (not self.db.AvA)) then
			self.db.Skills = LootDrop_sListBoxNo
		end
	end
end
-------------------------------------------------------------------------------
--- Check if any flags are set
-- if no flag is passed will check if any flag is set.
-- @tparam DirtyFlags flag
-- @treturn boolean
function LootDrop:IsDirty( flag )
	if ( not flag ) then return #self.dirty_flags ~= 0 end

	for _,v in pairs( self.dirty_flags ) do
		if ( v == flag ) then
			return true
		end
	end

	return false
end
-------------------------------------------------------------------------------
function LootDrop:OnMoveStop()
	if (not self.loaded) then
		return
	end
	
	local _, _, rightScreen, bottomScreen  = GuiRoot:GetScreenRect()
	local _, _, right, bottom = self.control:GetScreenRect()
	
	self.db.lootdrop_x = math.floor(right-rightScreen)
	self.db.lootdrop_y = math.floor(bottom-bottomScreen)
end
-------------------------------------------------------------------------------
--- On every consecutive frame
function LootDrop:OnUpdate( frameTime ) 

    if not self.loaded then
	   return
	end   

	if not #self._active then
	    if self.db.HideMeters then  
	        if IsInImperialCity() then ZO_HUDTelvarMeter:SetHidden(false) end -- show telvarUI
		    if GetBounty() ~= nil and GetBounty() > 0 and not IsInImperialCity() then ZO_HUDInfamyMeter:SetHidden(false) end-- show infamy meter
		end
		return
	end

	local i = 1
	local entry = nil
	local ft = GetFrameTimeMilliseconds()
	
	if self.db.HideMeters then
	   if #self._active > 0 then ZO_HUDTelvarMeter:SetHidden(true) ZO_HUDInfamyMeter:SetHidden(true)-- hide/show telvarUI & infamy meter
	   elseif IsInImperialCity() then ZO_HUDTelvarMeter:SetHidden(false)
	   elseif GetBounty() ~= nil and GetBounty() > 0 then ZO_HUDInfamyMeter:SetHidden(false)
	   end
    end 
	
    local mStacks = self.db.maxstacks

	while( i <= #self._active ) do
		entry = self._active[ i ]

		if ( ft - entry:GetTimestamp() > self.db.displayduration * 1000 ) then
			self:Release( entry )
			tinsert( self.dirty_flags, DirtyFlags.LAYOUT )
		else
		    if i > mStacks then entry.timestamp = ft end -- if entry number is more than mStacks we set the entry timestamp to now
            self:NoDuplicates(entry) 			
			i = i + 1
		end
	end
	
	if ( self:IsDirty( DirtyFlags.LAYOUT ) ) then
		local last_y = 0
		local last_x = 0
		local entry = nil

		if (not self.db.MoveUp) then
			local xdim, ydim = self.control:GetDimensions()
			--y is count from the bottom right, so the top is negative number
			last_y = ( self.db.height + self.db.padding ) - ydim
			last_x = ( self.db.width) - xdim
		end
		
		for i=1,#self._active do
			entry = self._active[ i ]

			if ( not entry:IsVisible() ) then
				if i <= mStacks then entry:Show( last_x, last_y ) end    -- if entry number is less than mStacks we show the entry 
			else 
                if i > mStacks then entry.control:SetAlpha( 0.0 ) end	-- if entry number is more than mStacks we hide the entry 		
				entry:Move( last_x, last_y )
			end
			
			if (self.db.MoveUp) then
				last_y = last_y - ( self.db.height + self.db.padding )
			else
				--y is count from the bottom right and last y is negative number
				last_y = last_y + ( self.db.height + self.db.padding )
			end
		end
	end

	self.dirty_flags = {}
end
-------------------------------------------------------------------------------
--- Create a new loot droppable
-- @tparam ZO_ObjectPool _ unused
function LootDrop:CreateDroppable()
	return LootDroppable:New( self )
end
-------------------------------------------------------------------------------
--- Reset a loot droppable
-- @tparam LootDroppable droppable 
function LootDrop:ResetDroppable( droppable, key )
	if ( key == self._coinId ) then
		self._coinId = nil
		self._coinLastVal = 0
	elseif( key == self._apId ) then
		self._apId = nil
		self._apLastVal = 0
	elseif( key == self._rpId ) then
		self._rpId = nil
		self._rpLastVal = 0
	elseif( key == self._tvId ) then
		self._tvId   = nil
		self._tvLastVal = 0
	elseif( key == self._wVoucherId ) then
		self._wVoucherId   = nil
		self._wVoucherLastVal = 0
	elseif( key == self._undauntedId ) then
		self._undauntedId   = nil
		self._undauntedLastVal = 0
	elseif( key == self._transmuteId ) then
		self._transmuteId   = nil
		self._transmuteLastVal = 0
	elseif( key == self._eticketId ) then
		self._eticketId   = nil
		self._eticketLastVal = 0
	elseif( key == self._xpId ) then
		self._xpId = nil
		self._xpLastVal = 0
	elseif( key == self._xpCompanionId ) then
		self._xpCompanionId = nil
		self._xpCompanionLastVal = 0
	elseif( key == self._rapportId ) then
		self._rapportId = nil
		self._rapportLastVal = 0
	elseif ( key == self._skillXpId ) then
		self._skillXpId = nil
		self._skillXpLastVal = 0
	elseif ( key == self._skillMageXpId ) then
		self._skillMageXpId = nil
		self._skillMageXpLastVal = 0
	elseif ( key == self._skillFighterXpId ) then
		self._skillFighterXpId = nil
		self._skillFighterXpLastVal = 0
	elseif ( key == self._skillThievesXpId ) then
		self._skillThievesXpId = nil
		self._skillThievesXpLastVal = 0
	elseif ( key == self._skillUndauntedXpId ) then
		self._skillUndauntedXpId = nil
		self._skillUndauntedXpLastVal = 0
	elseif ( key == self._skillPsijicXpId ) then
		self._skillPsijicXpId = nil
		self._skillPsijicXpLastVal = 0
	elseif ( key == self._skillBookXpId ) then
		self._skillBookXpId = nil
	elseif ( key == self._skillFenceXpId ) then
		self._skillFenceXpId = nil
		self._skillFenceXpLastVal = 0
	elseif ( key == self._skillBrotherhoodXpId ) then
		self._skillBrotherhoodXpId = nil
		self._skillBrotherhoodXpLastVal = 0
	else -- skill line reset
		for k, v in pairs(self._skillTableArmor) do v.key = nil v.val = 0 end
		for k, v in pairs(self._skillTableAvA) do v.key = nil v.val = 0 end
		for k, v in pairs(self._skillTableWeapon) do v.key = nil v.val = 0 end
		for k, v in pairs(self._skillTableWorld) do v.key = nil v.val = 0 end
	end

	droppable:Hide()
end
-------------------------------------------------------------------------------
function LootDrop:Acquire()
	local result, key = LootDropPool.Acquire( self )
	result:Prepare(self.db.MoveUp)

	tinsert( self.dirty_flags, DirtyFlags.LAYOUT )

	return result, key
end
-------------------------------------------------------------------------------
function LootDrop:FormatAmount( amount )
	return ZO_CommaDelimitNumber( amount )
end
-------------------------------------------------------------------------------
function LootDrop:ParseLink( link )
	if ( type( link ) ~= 'string' ) then
		return nil, nil
	end

	local text, color = zo_parselink( link )

	if (text=="") then
		text = link 
	end

	if color == "" or color == "0" or color == "1" then
		color = 'FFFFFF'
	end

	return text, color
end
-------------------------------------------------------------------------------
function LootDrop:NewParseLink( NewLink )
	if ( type( NewLink ) ~= 'string' ) then
		return nil, nil
	end

	local Text, LinkStyle = zo_parselink( NewLink )
	Text=zo_strformat("<<x:1>>", Text)

	if (Text=="") then
		Text = NewLink 
	end

	return Text, LinkStyle
end
-------------------------------------------------------------------------------
function LootDrop:ResetCurrentItemBag( )
	self.lastSingleSlotUpdateSlotId = nil
	self.lastSingleSlotUpdateBagId = nil
end
-------------------------------------------------------------------------------
function LootDrop:ResetItemToPrint( )
	self.ItemToPrint.iconFileName = [[/esoui/art/icons/icon_missing.dds]]
	self.ItemToPrint.color        = 'FFFFFF'
	self.ItemToPrint.quantity     = 0
	self.ItemToPrint.nb           = 0
	self.ItemToPrint.text         = ''
	self.ItemToPrint.tag          = ''
	self.ItemToPrint.itemStyle    = nil
end
-------------------------------------------------------------------------------
function LootDrop:OnSkillXPUpdated( eventCode,  skillType,  skillIndex,  reason,  rank,  previousXP,  currentXP) 

--[[ for reference...

-- SkillType
    -- SKILL_TYPE_ARMOR			3
    -- SKILL_TYPE_AVA			6
    -- SKILL_TYPE_CHAMPION		9
    -- SKILL_TYPE_CLASS			1
    -- SKILL_TYPE_GUILD			5
    -- SKILL_TYPE_NONE			0
    -- SKILL_TYPE_RACIAL		7
    -- SKILL_TYPE_TRADESKILL	8
    -- SKILL_TYPE_WEAPON		2
    -- SKILL_TYPE_WORLD 		4

-- reason
	-- PROGRESS_REASON_ACHIEVEMENT = 25
	-- PROGRESS_REASON_ACTION = 13
	-- PROGRESS_REASON_ALLIANCE_POINTS = 33
	-- PROGRESS_REASON_ANTIQUITY_COMPLETED_DIGGING = 42 -- new
	-- PROGRESS_REASON_ANTIQUITY_COMPLETED_SCRYING = 41 -- new
	-- PROGRESS_REASON_AVA = 15
	-- PROGRESS_REASON_BATTLEGROUND = 6
	-- PROGRESS_REASON_BOOK_COLLECTION_COMPLETE = 12
	-- PROGRESS_REASON_BOSS_KILL = 26
	-- PROGRESS_REASON_COLLECT_BOOK = 11
	-- PROGRESS_REASON_COMMAND = 4
	-- PROGRESS_REASON_COMPLETE_POI = 2
	-- PROGRESS_REASON_DARK_ANCHOR_CLOSED = 28
	-- PROGRESS_REASON_DARK_FISSURE_CLOSED = 29
	-- PROGRESS_REASON_DISCOVER_POI = 3
	-- PROGRESS_REASON_DRAGON_KILL = 39
	-- PROGRESS_REASON_DUNGEON_CHALLENGE = 35
	-- PROGRESS_REASON_EVENT = 27
	-- PROGRESS_REASON_FINESSE = 9
	-- PROGRESS_REASON_GRANT_REPUTATION = 32
	-- PROGRESS_REASON_GUILD_REP = 14
	-- PROGRESS_REASON_HARROWSTORM_COMPLETED = 40 -- new
	-- PROGRESS_REASON_JUSTICE_SKILL_EVENT = 36
	-- PROGRESS_REASON_KEEP_REWARD = 5
	-- PROGRESS_REASON_KILL = 0
	-- PROGRESS_REASON_LFG_REWARD = 37
	-- PROGRESS_REASON_LOCK_PICK = 10
	-- PROGRESS_REASON_MEDAL = 8
	-- PROGRESS_REASON_NONE = -1
	-- PROGRESS_REASON_OTHER = 31
	-- PROGRESS_REASON_OVERLAND_BOSS_KILL = 24
	-- PROGRESS_REASON_PVP_EMPEROR = 34
	-- PROGRESS_REASON_QUEST = 1
	-- PROGRESS_REASON_REWARD = 17
	-- PROGRESS_REASON_SCRIPTED_EVENT = 7
	-- PROGRESS_REASON_SKILL_BOOK = 30
	-- PROGRESS_REASON_TRADESKILL = 16
	-- PROGRESS_REASON_TRADESKILL_ACHIEVEMENT = 18
	-- PROGRESS_REASON_TRADESKILL_CONSUME = 20
	-- PROGRESS_REASON_TRADESKILL_HARVEST = 21
	-- PROGRESS_REASON_TRADESKILL_QUEST = 19
	-- PROGRESS_REASON_TRADESKILL_RECIPE = 22
	-- PROGRESS_REASON_TRADESKILL_TRAIT = 23
	-- PROGRESS_REASON_WORLD_EVENT_COMPLETED = 38
	]]

	local bprint=false
	local cprint=false
	local stacked=(self.db.Skills ~= LootDrop_sListBoxNotStacked)
	local tag=''
	local color='6BB5FF'
	local icon = LootDrop_sSkillXpIcon
	local dropid = self._skillXpId
	local lastval = self._skillXpLastVal
	local skillLineData = SKILLS_DATA_MANAGER:GetSkillLineDataByIndices(skillType, skillIndex)
	local lastSkillXP, nextSkillXP, currentSkillXP = GetSkillLineXPInfo(skillType, skillIndex)
	local isActive = (skillLineData:IsActive()) and true or false
	local maxedSkill = (nextSkillXP == 0)

	--Skill Xp from craft
	if (( skillType == SKILL_TYPE_TRADESKILL ) and (reason == PROGRESS_REASON_TRADESKILL)) then
		bprint=((self.db.Craft) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogCraftXP)
		tag='CRAFT'

		--[[ TradeskillType (CraftType)
			-- CRAFTING_TYPE_ALCHEMY			4
			-- CRAFTING_TYPE_BLACKSMITHING		1
			-- CRAFTING_TYPE_CLOTHIER			2
			-- CRAFTING_TYPE_ENCHANTING			3
			-- CRAFTING_TYPE_INVALID			0
			-- CRAFTING_TYPE_JEWELRYCRAFTING	7 -- new
			-- CRAFTING_TYPE_PROVISIONING		5
			-- CRAFTING_TYPE_WOODWORKING		6
			]]

		local CraftType = GetCraftingInteractionType()
		
		if (CraftType == CRAFTING_TYPE_BLACKSMITHING) then
			icon = LootDrop_sAnvilXpIcon
		elseif (CraftType == CRAFTING_TYPE_CLOTHIER) then
			icon = LootDrop_sClothierXpIcon
		elseif (CraftType == CRAFTING_TYPE_ENCHANTING) then
			icon = LootDrop_sEnchanterXpIcon
		elseif (CraftType == CRAFTING_TYPE_ALCHEMY) then
			icon = LootDrop_sAlchimyXpIcon
		elseif (CraftType == CRAFTING_TYPE_PROVISIONING) then
			icon = LootDrop_sProvisioningXpIcon
		elseif (CraftType == CRAFTING_TYPE_WOODWORKING) then
			icon = LootDrop_sWoodXpIcon
		elseif (CraftType == CRAFTING_TYPE_JEWELRYCRAFTING) then
			icon = LootDrop_sJewelrycraftingXpIcon
		else -- craft book
			bprint=((self.db.Books) and (self.db.Skills ~= LootDrop_sListBoxNo))
			cprint=(self.db.DbgLogBookKnowledge)
			tag='BOOK'
			icon = LootDrop_sBooksXpIcon
			dropid = self._skillBookXpId
			lastval = 0
		end

	--Skill Xp GUILD REPUTATION
	elseif ( skillType == SKILL_TYPE_GUILD ) then
		bprint=((self.db.Guilds) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogGuildRep)
		tag='GUILD'

		if ( skillIndex == 1 ) then -- Dark Brotherhood
			icon = (self.db.oldicons) and LootDrop_sBrotherhoodXpIcon or skillLineData:GetAnnounceIcon()
			dropid = self._skillBrotherhoodXpId
			lastval = self._skillBrotherhoodXpLastVal
		elseif ( skillIndex == 2 ) then -- Fighters Guild
			icon = (self.db.oldicons) and LootDrop_sFighterGuildXpIcon or skillLineData:GetAnnounceIcon()
			dropid = self._skillFighterXpId
			lastval = self._skillFighterXpLastVal
		elseif ( skillIndex == 3 ) then -- Mages Guild
			icon = (self.db.oldicons) and LootDrop_sMagesGuildXpIcon or skillLineData:GetAnnounceIcon()
			dropid = self._skillMageXpId
			lastval = self._skillMageXpLastVal
		elseif ( skillIndex == 4 ) then -- Psijic Order
			icon = skillLineData:GetAnnounceIcon()
			dropid = self._skillPsijicXpId
			lastval = self._skillPsijicXpLastVal
		elseif ( skillIndex == 5 ) then -- Thieves Guild
			icon = (self.db.oldicons) and LootDrop_sThievesXpIcon or skillLineData:GetAnnounceIcon()
			dropid = self._skillThievesXpId
			lastval = self._skillThievesXpLastVal
		elseif ( skillIndex == 6 ) then -- Undaunted
			icon = skillLineData:GetAnnounceIcon()
			dropid = self._skillUndauntedXpId
			lastval = self._skillUndauntedXpLastVal
		else
			icon = LootDrop_sOthersGuildXpIcon
			dropid = self._skillUndauntedXpId
			lastval = self._skillUndauntedXpLastVal
		end
	--Skill XP from books in library
	elseif (reason == PROGRESS_REASON_SKILL_BOOK) then
		bprint=((self.db.Books) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogBookKnowledge)
		tag='BOOK'
		icon = LootDrop_sBooksXpIcon
		dropid = self._skillBookXpId
		lastval = 0
	-- Fence skilline
	elseif (reason == PROGRESS_REASON_JUSTICE_SKILL_EVENT) then
		bprint=((self.db.Fence) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogFenceXP)
		tag='FENCE'
		icon = LootDrop_sFenceXpIcon
		dropid = self._skillFenceXpId
		lastval = self._skillFenceXpLastVal
	--Skill Xp WORLD REPUTATION
	elseif ( skillType == SKILL_TYPE_WORLD ) then
		if maxedSkill or not isActive then return end -- for some reason the game shows you gaining vampire experience even when you don't have it
		if not self._skillTableWorld[skillIndex] then return end
		bprint=((self.db.World) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogWorld)
		tag = self._skillTableWorld[skillIndex].tag
		icon = self._skillTableWorld[skillIndex].icon
		dropid = self._skillTableWorld[skillIndex].key
		lastval = self._skillTableWorld[skillIndex].val
	--Skill Xp WEAPON PROGRESS
	elseif ( skillType == SKILL_TYPE_WEAPON ) then
		if maxedSkill or not isActive then return end
		if not self._skillTableWeapon[skillIndex] then return end
		bprint=((self.db.Weapon) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogWeapon)
		tag = self._skillTableWeapon[skillIndex].tag
		icon = self._skillTableWeapon[skillIndex].icon
		dropid = self._skillTableWeapon[skillIndex].key
		lastval = self._skillTableWeapon[skillIndex].val
	--Skill Xp ARMOR PROGRESS
	elseif ( skillType == SKILL_TYPE_ARMOR ) then
		if maxedSkill or not isActive then return end
		if not self._skillTableArmor[skillIndex] then return end
		bprint=((self.db.Armor) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogArmor)
		tag = self._skillTableArmor[skillIndex].tag
		icon = self._skillTableArmor[skillIndex].icon
		dropid = self._skillTableArmor[skillIndex].key
		lastval = self._skillTableArmor[skillIndex].val
	--Skill Xp AvA PROGRESS
	elseif ( skillType == SKILL_TYPE_AVA ) then
		if maxedSkill or not isActive then return end
		if not self._skillTableAvA[skillIndex] then return end
		bprint=((self.db.AvA) and (self.db.Skills ~= LootDrop_sListBoxNo))
		cprint=(self.db.DbgLogAvA)
		tag = self._skillTableAvA[skillIndex].tag
		icon = self._skillTableAvA[skillIndex].icon
		dropid = self._skillTableAvA[skillIndex].key
		lastval = self._skillTableAvA[skillIndex].val
	end

--	d(skillType)
--	d(skillIndex)
--	d(reason)

	local RealGain = currentXP-previousXP
	local skillName, skillRank = GetSkillLineInfo(skillType, skillIndex)
	local SkillXp = (currentSkillXP - lastSkillXP) -- levelCurrent
	local SkillXpTotal = SkillXp
	if (not maxed) then
		SkillXpTotal = nextSkillXP - lastSkillXP -- levelCap
	end

	--DROP LABEL (RealGain value could be stacked in SetSkillNewDrop)
	local pccurrent=0
	if (SkillXpTotal>0) then
		pccurrent = math.floor(100*(SkillXp/SkillXpTotal))
	end


	local sLevel = L.LevelPsijic.." ".. tostring(skillRank)
	local sName = (self.db.SkillNames) and zo_strformat( '|cFFFFFF<<1>>|r ', skillName ) or ""
	local pctexts = zo_strformat( zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..'|c6BB5FF<<1>>|r |c808080(<<2>>%)|r', sLevel, pccurrent )
	local finaltext = (self.db.Skills == LootDrop_sListBoxExtended) and zo_strformat( '<<1>> <<2>>', pctexts, sName) or sName

	--DBG LOG (always not stacked)
	local finaldbgtext = zo_strformat( '|c6BB5FF<<1>>|r  <<2>>  |c736F6E<<3>>/<<4>>|r  |cFFFFFF[<<t:5>>]|r', self:FormatAmount(RealGain), pctexts, self:FormatAmount(SkillXp), self:FormatAmount(SkillXpTotal), skillName )
	local dropidout, lastvalout = self:SetNewDrop(stacked, dropid, color, icon, lastval, RealGain, finaltext, finaldbgtext, tag, skillType,  skillIndex, skillRank, bprint, cprint)

	if (bprint) then
		--CRAFT
		if (( skillType == SKILL_TYPE_TRADESKILL ) and (reason == PROGRESS_REASON_TRADESKILL)) then
			self._skillXpId = dropidout
			self._skillXpLastVal = lastvalout
		--GUILD REPUTATION
		elseif ( skillType == SKILL_TYPE_GUILD ) then
			if ( skillIndex == 1 ) then
				self._skillBrotherhoodXpId = dropidout
				self._skillBrotherhoodXpLastVal = lastvalout
			elseif ( skillIndex == 2 ) then
				self._skillFighterXpId = dropidout
				self._skillFighterXpLastVal = lastvalout
			elseif ( skillIndex == 3 ) then
				self._skillMageXpId = dropidout
				self._skillMageXpLastVal = lastvalout
			elseif ( skillIndex == 4 ) then
				self._skillThievesXpId = dropidout
				self._skillThievesXpLastVal = lastvalout
			elseif ( skillIndex == 5 ) then
				self._skillUndauntedXpId = dropidout
				self._skillUndauntedXpLastVal = lastvalout
			elseif ( skillIndex == 6 ) then
				self._skillPsijicXpId = dropidout
				self._skillPsijicXpLastVal = lastvalout
			else
				self._skillUndauntedXpId = dropidout
				self._skillUndauntedXpLastVal = lastvalout
			end
		--BOOKS
		elseif (reason == PROGRESS_REASON_SKILL_BOOK) then
			self._skillBookXpId = dropidout
		-- FENCE
		elseif (reason == PROGRESS_REASON_JUSTICE_SKILL_EVENT) then
			self._skillFenceXpId = dropidout
			self._skillFenceXpLastVal = lastvalout
		-- WORLD SKILL
		elseif ( skillType == SKILL_TYPE_WORLD ) then
			self._skillTableWorld[skillIndex].key = dropidout
			self._skillTableWorld[skillIndex].val = lastvalout
		-- AvA SKILL
		elseif ( skillType == SKILL_TYPE_AVA ) then
			self._skillTableAvA[skillIndex].key = dropidout
			self._skillTableAvA[skillIndex].val = lastvalout
		-- WEAPON SKILL
		elseif ( skillType == SKILL_TYPE_WEAPON ) then
			self._skillTableWeapon[skillIndex].key = dropidout
			self._skillTableWeapon[skillIndex].val = lastvalout
		-- ARMOR SKILL
		elseif ( skillType == SKILL_TYPE_ARMOR ) then
			self._skillTableArmor[skillIndex].key = dropidout
			self._skillTableArmor[skillIndex].val = lastvalout
		end
	end
end
-------------------------------------------------------------------------------
function LootDrop:SetNewDrop(stacked, dropid, color, icon, lastval, val, label, dbglabel, tag, skillType, skillIndex, skillRank, bprint, cprint)
	if ((label ~= nil) and (color ~= nil) and (val ~= 0)) then
		local newDrop = nil
        local pop = false

		if (bprint) then -- allowing to enable chat output when loot display disabled (Phinix)
			if (stacked) then
				if ( dropid ) then
					newDrop = self:Get( dropid )
					if ( newDrop ) then
						pop = true
						val = val + lastval
					end
				end
			end

			if ( not newDrop ) then
				newDrop, dropid = self:Acquire()
			end
		end

		lastval = val

		if (bprint) then
			local zo_color = ZO_ColorDef:New( color )
			newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
			newDrop:SetBackground()
			newDrop:SetLabelSize( self.db.FontSize )
			newDrop:SetRarity( zo_color, self.db.rarity )
			newDrop:SetIcon( icon )
			
				
	        local xp = ""
	        if self.db.sListStyle==LootDrop_sDefESOclassic then	
	           xp = "xp"	
	        end
	
			local slabel = zo_strformat( '|c6BB5FF<<1>>'..xp..'|r  <<2>>', string.format("%+d", val), label)
			if (( skillType == SKILL_TYPE_GUILD ) and ( skillIndex == 4 )) then -- special case for Psijic Order progress always jumps by whole level
				local pName = L.LevelPsijic.. " " .. tostring(skillRank)
				slabel = zo_strformat('|c6BB5FF<<1>>|r', pName)
			end
	
			newDrop:SetLabel(slabel)
		end

		if (cprint) then
			if dbglabel == nil then dbglabel = slabel end
			self:ChatOutput(icon, 1, dbglabel, tag, true)
		end

		if ( pop ) then
			local anim = self._pop:Apply( newDrop.control )
			anim:Forward()
		end
	end

	return dropid, lastval
end
-------------------------------------------------------------------------------
function LootDrop:GetStyleColoredString( itemStyle )
	local StyleColoredString = nil
	--style info
	if (itemStyle and (not (itemStyle == ITEMSTYLE_NONE or itemStyle == ITEMSTYLE_UNIVERSAL))) then
		
		local stylestring = GetItemStyleName(itemStyle)

	-- it doesn't really make sense to try and individually color by item style anymore... may revisit
	--	local color = "FFFFFF"
	--	if itemStyle >= ITEMSTYLE_RACIAL_BRETON and itemStyle <= ITEMSTYLE_RACIAL_KHAJIIT then
	--		color = GetItemQualityColor(ITEM_QUALITY_ARCANE)
	--	elseif itemStyle == ITEMSTYLE_RACIAL_IMPERIAL or itemStyle == ITEMSTYLE_AREA_DWEMER or itemStyle == ITEMSTYLE_GLASS or itemStyle == ITEMSTYLE_AREA_XIVKYN then
	--		color = GetItemQualityColor(ITEM_QUALITY_LEGENDARY)
	--	else
	--		color = GetItemQualityColor(ITEM_QUALITY_ARTIFACT)
	--	end

		local color = ZO_ColorDef:New({["r"]=0,["g"]=0.847,["b"]=1,["a"]=0.6}) -- set a custom color instead, ZO_ColorDef gives us ToHex()

		StyleColoredString = zo_strformat("|c<<1>> [<<2>>]|r", color:ToHex(), stylestring)

	end

	return StyleColoredString
	
end
-------------------------------------------------------------------------------
-- Called when one of your bag (inventory, bank, gbank, buyback ..) is updated -- Huge source of lua consumption
function LootDrop:OnSingleSlotUpdate(_, bagId, slotId, isNew, soundCategory, updateReason, stackChange)
	if IsUnderArrest() == false then
		self.lastSingleSlotUpdateSlotId = slotId
		self.lastSingleSlotUpdateBagId = bagId

		-- special case for soul gems gained by Soul Trap, Soul Lock passive, or other such means. (phinix)
		if stackChange > 0 and isNew then
			local itemLink = GetItemLink(bagId, slotId, LINK_STYLE_DEFAULT)
			local checkName = GetItemLinkName(itemLink)
			if (checkName == LootDrop_SoulGem or checkName == LootDrop_EmptyGem) and not self.lootBuffer then
				local itemId = GetItemId(bagId, slotIndex)
				local icon, _, _, _, itemStyle   = GetItemLinkInfo(itemLink)
				local color = GetItemQualityColor(GetItemLinkQuality(itemLink))
				local quantity = stackChange
				local unitName = GetRawUnitName("player")
				local lootType = LOOT_TYPE_ITEM
				local newDrop, _ = self:Acquire()
				self.ItemToPrint.tag = 'INV'
				self.ItemToPrint.itemStyle = self:GetStyleColoredString( itemStyle )
				self.ItemToPrint.nb = GetSlotStackSize(self.lastSingleSlotUpdateBagId, self.lastSingleSlotUpdateSlotId)
				self:ResetCurrentItemBag()
				self.lootBuffer = true
				zo_callLater(function() self.lootBuffer = nil end, 100) -- the game fires soul gem gains twice for some weird reason so buffer (Phinix)
				
				self:LootPrint(newDrop, icon, color, quantity, itemLink, true, unitName, lootType, itemId)

			--	d("testing...")			
			end
		end

		-- for mail loot
		if ( self.db.mailloot ) then
			for mailitemindex, item in pairs(self.MailStacks) do
				local itemLink = GetItemLink(bagId, slotId, LINK_STYLE_DEFAULT)
				-- itemLink can't be used as comparator because on hirelings mails (only thoses?), itemLink is incorrect
				local itemName = GetItemLinkName(itemLink)
				if (itemLink == item.itemLink) or (itemName == item.itemName)then
					item.bagId = bagId
					item.slotId = slotId
					break
				end
			end
		end
	end
end
-------------------------------------------------------------------------------
--- Called when you loot an Item
-- @tparam string itemLink
-- @tparam number quantity
-- @tparam boolean mine
-- @tparam number itemId
function LootDrop:OnLootReceived(unitName, itemLink, quantity, _, lootType, mine, _, _, itemId)
	-- itemId returns the antiquity ID if lootType = LOOT_TYPE_ANTIQUITY_LEAD (12) (phinix)
	-- itemLink can be an itemName if lootType == LOOT_TYPE_QUEST_ITEM. itemId param #9 can't be used for this lootType, questItemIcon returns nil
	if not mine and (not self.db.DbgLogOthers or lootType == LOOT_TYPE_QUEST_ITEM) then
		return
	end
	
	local isStolen = IsItemStolen(self.lastSingleSlotUpdateBagId, self.lastSingleSlotUpdateSlotId) and GetItemLinkName(itemLink) == GetItemName(self.lastSingleSlotUpdateBagId, self.lastSingleSlotUpdateSlotId)

	local checkName = GetItemLinkName(itemLink)
	if (checkName == LootDrop_SoulGem or checkName == LootDrop_EmptyGem) then -- ignore actual looted soul gems to avoid duplicates from OnSingleSlotUpdate fix (phinix)
	--	d("Soul gem loot test...")
		return
	end

	local icon, color
	if lootType == LOOT_TYPE_QUEST_ITEM then
		self.ItemToPrint.tag = 'QUEST'

		-- searching for item in questCache to get its icon
		for journalIndex, questData in pairs(SHARED_INVENTORY.questCache) do
			for itemIndex, itemData in pairs (questData) do
				if itemData.name == zo_strformat(SI_TOOLTIP_ITEM_NAME, itemLink) then
					icon = itemData.iconFile
					break
				end
			end
		end
		
		self.ItemToPrint.nb = GetSlotStackSize(self.lastSingleSlotUpdateBagId, self.lastSingleSlotUpdateSlotId)
		self:ResetCurrentItemBag()
		

		if ( (not icon) or (icon == '') or (icon == [[/esoui/art/icons/icon_missing.dds]])) then
			icon = [[/esoui/art/inventory/inventory_tabicon_quest_down.dds]]
		end

		color = GetItemQualityColor(GetItemLinkQuality(nil))

	elseif lootType == LOOT_TYPE_ANTIQUITY_LEAD then -- itemId returns the antiquity ID in this context
		self.ItemToPrint.tag = 'ANTIQUITY'

		itemLink = GetAntiquityName(itemId)
		icon = GetAntiquityIcon(itemId)
		color = GetAntiquityQualityColor(GetAntiquityQuality(itemId))
		quantity = (not quantity or quantity < 1) and 1 or quantity

	elseif lootType == LOOT_TYPE_COLLECTIBLE then -- itemId returns the collectible ID in this context
		self.ItemToPrint.tag = 'COLLECTIBLE'

		itemLink = GetCollectibleLink(itemId, LINK_STYLE_DEFAULT)
		icon = GetCollectibleIcon(itemId)
		color = GetItemQualityColor(GetItemLinkQuality(itemLink))
		quantity = (not quantity or quantity < 1) and 1 or quantity

	else

		local itemStyle
		icon, _, _, _, itemStyle   = GetItemLinkInfo(itemLink)
		color                      = GetItemQualityColor(GetItemLinkQuality(itemLink))
		self.ItemToPrint.tag       = 'INV'
		self.ItemToPrint.itemStyle = self:GetStyleColoredString( itemStyle )

		if mine then
			if self.db.Junk and GetItemLinkItemType(itemLink) == ITEMTYPE_TRASH and IsItemJunk(self.lastSingleSlotUpdateBagId, self.lastSingleSlotUpdateSlotId) == false then
				SetItemIsJunk(self.lastSingleSlotUpdateBagId, self.lastSingleSlotUpdateSlotId, true)
				self.ItemToPrint.tag = 'JUNK'
			end
			self.ItemToPrint.nb = GetSlotStackSize(self.lastSingleSlotUpdateBagId, self.lastSingleSlotUpdateSlotId)
			self:ResetCurrentItemBag()
		end
	end

	local newDrop, _ = self:Acquire()
	self:LootPrint(newDrop, icon, color, quantity, itemLink, mine, unitName, lootType, itemId, isStolen)

end
-------------------------------------------------------------------------------
-- Calledn when you read a mail
function LootDrop:OnMailReadable(mailId)

	self.MailStacks = {}

	for attachIndex = 1, GetMailAttachmentInfo( mailId ) do
		self.MailStacks[attachIndex] = {}
		local icon, stack, _, _, _, _, itemStyle, quality = GetAttachedItemInfo( mailId, attachIndex)
		local mailitemlink                                = GetAttachedItemLink( mailId, attachIndex, LINK_STYLE_DEFAULT)
		local mailitemName                                = GetItemLinkName(mailitemlink)
		self.MailStacks[attachIndex].icon                 = icon
		self.MailStacks[attachIndex].stack                = stack
		self.MailStacks[attachIndex].itemLink             = mailitemlink
		self.MailStacks[attachIndex].itemName             = mailitemName
		self.MailStacks[attachIndex].itemStyle            = self:GetStyleColoredString( itemStyle )
		self.MailStacks[attachIndex].quality              = quality
	end
end
-------------------------------------------------------------------------------
-- Called (a single time) when you take mail attachments
function LootDrop:OnMailItemLooted(mailId)

	-- Buggy if bag is full, it will consider all items as looted, even if only some are not.

	for mailitemindex, item in pairs(self.MailStacks) do
		
		if item.itemName == LootDrop_SoulGem then -- ignore actual looted soul gems to avoid duplicates from OnSingleSlotUpdate fix (phinix)
			--d("Soul gem mail test...")
			return
		end

		local color = GetItemQualityColor(item.quality)

		self.ItemToPrint.nb        = GetSlotStackSize(item.bagId, item.slotId)
		self.ItemToPrint.tag       = 'MAIL'
		self.ItemToPrint.itemStyle = item.itemStyle

		local newDrop, _ = self:Acquire()
		self:LootPrint(newDrop, item.icon, color, item.stack, item.itemLink, true)

	end

	self.MailStacks = {}
	self:ResetCurrentItemBag()
	
end
-------------------------------------------------------------------------------
-- Print a loot in LootDrop Gui and send it to chat if enabled
function LootDrop:LootPrint(newDrop, icon, c, quantity, text, mine, unitName, lootType, itemId, isStolen)

-- currently only Antiquity Leads are passing 'lootType' and 'itemId' so checking for these effectively checks if drop is antiquity
-- however we still test if lootType == LOOT_TYPE_ANTIQUITY_LEAD so it is clear if future item types are added that need support.

	if ( not icon or icon == '' )then
		icon = [[/esoui/art/icons/icon_missing.dds]]
	end
	
	local color = c:ToHex()
	local guiName = text
	local quality = ITEM_QUALITY_TRASH
	-- Remove ItemLink for LootDropGui, because of some rare items with wrong itemLink in FR/DE. (ex few set items - |H1:item:55383:283:50:0:0:0:0:0:0:0:0:0:0:0:0:33:0:0:0:0:0|h|h)
	if string.find(text, "|H(.-):item:(.-)|h(.-)|h") then
		guiName = zo_strformat("|c<<1>><<2>>|r", color, zo_strformat(SI_TOOLTIP_ITEM_NAME, GetItemLinkName(text)))
		quality = GetItemLinkQuality(text)
	elseif lootType and lootType == LOOT_TYPE_ANTIQUITY_LEAD then -- treat antiquity leads separate from quest items and colorize
		guiName = zo_strformat("|c<<1>><<2>>|r", color, text)
		quality = GetAntiquityQuality(itemId)
	else
		-- Quest items
		guiName = zo_strformat(SI_TOOLTIP_ITEM_NAME, text)
	end

	text = zo_strformat(SI_TOOLTIP_ITEM_NAME, text)

--	local label = zo_strformat(" <<1[//$dx]>> <<t:2>>", quantity, guiName ) -- this class syntax prevents quantity display in Russian client, maybe others (phinix)
	local label = (quantity > 1) and " "..tostring(quantity).."x "..guiName or " "..guiName

	local tag = self.ItemToPrint.tag

	if not self.db.nameloot and (tag == "INV" or tag == "JUNK" or tag == "MAIL") then
	--	label = zo_strformat(" <<1[//$dx]>>", quantity )
		label = (quantity > 1) and " "..tostring(quantity).."x " or " "
	end

	local invstack = ""
	local style = ""
	local value = ""
	local MM = 0
	local ATT = 0
	local TTC = 0
	local rVal = self.db.valueround
	local stolen = ""
	
	if isStolen then stolen = zo_iconTextFormatNoSpace("esoui/art/inventory/gamepad/gp_inventory_icon_stolenitem.dds",28,28,"") end 

	if tag == "INV" or tag == "JUNK" or tag == "MAIL" then
		if self.db.stackloot and self.ItemToPrint.nb ~= quantity then
		  local bag = "esoui/art/mainmenu/menubar_inventory_up.dds"
		  if self.lastSingleSlotUpdateBagId == BAG_VIRTUAL then bag = "esoui/art/inventory/inventory_tabicon_craftbag_up.dds" end 

			invstack = zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_strformat(zo_iconTextFormatNoSpace(bag,28,28,"").."|cFFFFFF<<1>>|r", self.ItemToPrint.nb) 
		end
		if self.db.styleloot and self.ItemToPrint.itemStyle then
			style = self.ItemToPrint.itemStyle
		end

		-- set the value display based on selected option (phinix)
		local option = self.db.valueloot
		local val = GetItemLinkValue(text)
		local mult = tostring(val * quantity)
		if option == 1 then
			if self.db.stackval then
				value = " " .. mult .. " |t16:16:/esoui/art/currency/currency_gold.dds|t"
			else
				value = " " .. val .. " |t16:16:/esoui/art/currency/currency_gold.dds|t"
			end
		elseif option > 1 then
			function Round(number, decimals) -- Round number to decimals number of places.
				local tDec = math.floor(decimals)
				if tDec >= 0 then
					return tonumber(string.format("%." .. (tDec or 0) .. "f", number))
				else
					return 0
				end
			end
			if TamrielTradeCentre ~= nil then
				local priceInfo = TamrielTradeCentrePrice:GetPriceInfo(text)
				if(priceInfo == nil) then
					TTC = 0
				else
					if priceInfo.SuggestedPrice then
						TTC = priceInfo.SuggestedPrice
					else 
						TTC = priceInfo.Avg
					end
				end
			end
			if MasterMerchant ~= nil then 
				local mmData = MasterMerchant:itemStats(text, false)
				if(mmData.avgPrice == nil or mmData.avgPrice == 0) then
					MM = 0
				else
					MM = mmData.avgPrice
				end
			end
			if ArkadiusTradeTools ~= nil then 
				local avgPrice = ArkadiusTradeTools.Modules.Sales:GetAveragePricePerItem(text, nil, nil)
				if(avgPrice == nil or avgPrice == 0) then
					ATT = 0
				else
					ATT = avgPrice
				end
			end
			local tVals = {[1] = MM, [2] = ATT, [3] = TTC}
			local tCount = 0
			local tVal = 0
			for k, v in pairs(tVals) do
				if v > 0 then
					tCount = tCount + 1
					tVal = tVal + v
				end
			end
			if tCount > 0 then tVal = tVal / tCount end
			local tmult = tostring(Round(tVal * quantity, rVal))
			local nData = (self.db.nodata) and ", " .. L.ValueNone or ""

			if option == 2 then
				if tVal == 0 then
					value = nData
				else
					if self.db.stackval then
						value = " " .. tmult .. " |t16:16:/esoui/art/currency/currency_gold.dds|t"
					else
						value = " " .. tostring(Round(tVal, rVal)) .. " |t16:16:/esoui/art/currency/currency_gold.dds|t"
					end
				end
			elseif option == 3 then
				if tVal == 0 then
					if self.db.stackval then
						value = " " .. mult .. " |t16:16:/esoui/art/currency/currency_gold.dds|t" .. nData
					else
						value = " " .. val .. " |t16:16:/esoui/art/currency/currency_gold.dds|t" .. nData
					end
				else
					if self.db.stackval then
						value = " " .. mult .. " |t16:16:/esoui/art/currency/currency_gold.dds|t" .. ", " .. tmult .. " |t16:16:/esoui/art/currency/currency_gold.dds|t"
					else
						value = " " .. val .. " |t16:16:/esoui/art/currency/currency_gold.dds|t" .. ", " .. tostring(Round(tVal, rVal)) .. " |t16:16:/esoui/art/currency/currency_gold.dds|t"
					end
				end
			end
		end
	elseif tag == "QUEST" then -- an icon for looted quest items
	   local bag = "esoui/art/tutorial/inventory_tabicon_quest_up.dds" 
	   local stackNb = self.ItemToPrint.nb
	   if not self.db.stackloot or self.ItemToPrint.nb < 2 or self.ItemToPrint.nb == nil then stackNb = "" end
       invstack = zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_strformat(zo_iconTextFormatNoSpace(bag,28,28,"").."|cFFFFFF<<1>>|r", stackNb)	
	end




	if mine then
	
		label = stolen..label..invstack..style..value
		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( c , self.db.rarity)
		newDrop:SetIcon( icon )
		newDrop:SetLabel( label )
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
	

	self:ChatOutput(icon, quantity, text, tag, mine, unitName, quality, value)
	self:ResetItemToPrint()

end
-------------------------------------------------------------------------------
--- Called when the amount of money you have changes
-- @tparam number money 
function LootDrop:OnMoneyUpdated( newMoney, oldMoney )
	local difference = newMoney - oldMoney
	local RealDiff=difference
	local displayMode = self.db.coin
	local pop = false
	local newDrop = nil

	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._coinId ) then
			newDrop = self:Get( self._coinId )
			if ( newDrop ) then
				pop = true
				difference = difference + self._coinLastVal
			end
		end

		if ( not newDrop ) then
			newDrop, self._coinId = self:Acquire()
		end
	end

	self._coinLastVal = difference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFF66'
	
		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( [[/esoui/art/icons/item_generic_coinbag.dds]] )
	
		if displayMode == LootDrop_sListBoxExtended and difference ~= newMoney then -- display gold
			newDrop:SetLabel(zo_strformat('<<1>>g', string.format("%+d", difference))..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_strformat(zo_iconTextFormatNoSpace("esoui/art/mainmenu/menubar_inventory_up.dds",28,28,"")..'|cFFFFFF<<1>>g|r', self:FormatAmount(newMoney)))
		else
			newDrop:SetLabel(  string.format("%+d", difference) )
		end
	end

	if (self.db.DbgLogGold) then
		local text=zo_strformat('<<1>>  |c736F6E-> <<2>>|r', self:FormatAmount(RealDiff), self:FormatAmount(newMoney))
		self:ChatOutput([[/esoui/art/icons/item_generic_coinbag.dds]], 1, text, '', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnXPUpdated( _, level, previousExperience, currentExperience, championPoints )
	local gain = currentExperience - previousExperience
	local maxLevel = GetMaxLevel()
	local displayMode = self.db.experience
	local level = GetUnitLevel("player")
	local cLevel = GetUnitChampionPoints("player")
	local realLevel = L.LevelPsijic.." "..level
    if level == 50 then realLevel = zo_iconTextFormatNoSpace("esoui/art/champion/champion_icon_32.dds",28,28,"")..cLevel end	
	

	if (gain <= 0) then return end -- no gain so nothing to display

	local RealDiff=gain
	local pop = false
	local newDrop = nil
	
	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._xpId ) then
			newDrop = self:Get( self._xpId )
	
			if ( newDrop ) then
				pop = true
				gain = gain + self._xpLastVal
			end
		end
	
		if ( not newDrop ) then
			newDrop, self._xpId = self:Acquire()
		end
	end

	self._xpLastVal = gain

	local xpForLevelUp
	if level < maxLevel then
		xpForLevelUp = GetNumExperiencePointsInLevel(level)
	else
		local cPoints = GetNumChampionXPInChampionPoint(championPoints)
		xpForLevelUp = (cPoints ~= nil) and cPoints or 0
	end

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFFFF'
		local xp = ''
		if (self.db.sListStyle==LootDrop_sDefPawkette) then
			c = '00FF00'
		elseif self.db.sListStyle==LootDrop_sDefESOclassic then	
		    xp = "xp"	
		end
		
		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( LootDrop_sXpIcon )

		if (displayMode == LootDrop_sListBoxExtended) then
			local pcgain = 0
			local pccurrent = 100
	
			if (xpForLevelUp > 0) then
				local gDif = 100*(gain/xpForLevelUp) -- show decimal values if gain is <1%
				pccurrent = math.floor(100*(currentExperience/xpForLevelUp))
				pcgain = (gDif < 1) and string.format("%.2f",tostring(gDif)) or math.floor(gDif)
			end
	
			local pctexts = zo_strformat( '|c736F6E(+<<1>>% -> <<2>>%)|r', pcgain, pccurrent )
			if GetPlayerChampionPointsEarned() == 3600 then
				newDrop:SetLabel( zo_strformat('<<1>>', string.format("%+d", gain)))
			else
				newDrop:SetLabel( zo_strformat('<<1>> <<2>>', string.format("%+d", gain), pctexts))
			end
		elseif (displayMode == LootDrop_sListBoxHalfExtended) then
			local pccurrent = 100
	
			if (xpForLevelUp > 0) then
				local gDif = 100*(gain/xpForLevelUp) -- show decimal values if gain is <1%
				pccurrent = math.floor(100*(currentExperience/xpForLevelUp))
			end
	
			local pctexts = zo_strformat( '|c808080(<<1>>%)|r', pccurrent )
			if GetPlayerChampionPointsEarned() == 3600 then
				newDrop:SetLabel( zo_strformat('<<1>>'..xp, string.format("%+d",gain)))
			else
				newDrop:SetLabel( zo_strformat('<<1>>'..xp..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..realLevel..' <<2>>', string.format("%+d",gain), pctexts))
			end
		else
			newDrop:SetLabel( string.format("%+d",gain) )
		end
	end

	if (self.db.DbgLogXP) then
		local text = ""
		if level == maxLevel and GetPlayerChampionPointsEarned() == 3600 then
			text = zo_strformat('<<1>>', self:FormatAmount(RealDiff))
		else
			text = zo_strformat('<<1>>  |c736F6E-> <<2>>/<<3>> (<<4>>%)|r', self:FormatAmount(RealDiff), self:FormatAmount(currentExperience), self:FormatAmount(xpForLevelUp), math.floor(tostring(100*(currentExperience/xpForLevelUp))))
		end
		self:ChatOutput(LootDrop_sXpIcon, 1, text, 'XP', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnAPUpdate( alliancePoints, playSound, difference )
	local newAlliancePoints = GetCurrencyAmount(CURT_ALLIANCE_POINTS, CURRENCY_LOCATION_CHARACTER)
	local displayMode = self.db.alliance

	if (self.current_ap == newAlliancePoints or displayMode == LootDrop_sListBoxNo) then return end
	self.current_ap = newAlliancePoints

	local pop = false
	local newDrop = nil
	local rankPoints = GetUnitAvARankPoints("player")
	local _, _, rankStartsAt, nextRankAt = GetAvARankProgress(rankPoints) -- Returns: subRankStartsAt, nextSubRankAt, rankStartsAt, nextRankAt
	local pointsNeededForRank = nextRankAt - rankStartsAt
	local actualPointsInRank = rankPoints - rankStartsAt
	local rdifference = actualPointsInRank - self.current_rp
	self.current_rp = actualPointsInRank
	local rankIcon = GetAvARankIcon( GetUnitAvARank("player"))

	local RealAPDiff=difference
	local RealRPDiff=rdifference
	
	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if (displayMode ~= LootDrop_sListBoxNotStacked) then
			if ( self._apId ) then
				newDrop = self:Get( self._apId )
				if ( newDrop ) then
					pop = true
					difference = difference + self._apLastVal
					rdifference = rdifference + self._rpLastVal
				end
			end
		end
	
		if ( not newDrop ) then
			newDrop, self._apId = self:Acquire()
		end
	end

	self._apLastVal=difference
	self._rpLastVal=rdifference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'C5FFC0'
		if (self.db.sListStyle==LootDrop_sDefPawkette) then
			c = '0000FF'
		end

		newDrop:SetTimestamp( GetFrameTimeMilliseconds() ) 
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ) , self.db.rarity)
		newDrop:SetIcon( LootDrop_sApIcon )
	
		local rdText = tostring(rdifference)
		 
		
		if (displayMode == LootDrop_sListBoxExtended) then
			local pcgain = 0
			local pccurrent=100
			local maxRank = 50
			local maxRankPointsAt = GetNumPointsNeededForAvARank(maxRank)
	
			if (pointsNeededForRank>0 and pointsNeededForRank ~= maxRankPointsAt) then
				local gDif = 100*(difference/pointsNeededForRank) -- show decimal values if difference is <1%
				pccurrent = math.floor(100*(actualPointsInRank/pointsNeededForRank))
				pcgain = (gDif < 1) and string.format("%.2f",tostring(gDif)) or math.floor(gDif)
			end
	
			local pctexts = ""
			if rdifference > 0 then
				pctexts = zo_strformat( '|c00FF00RP|r '..rdText..' |c736F6E(+<<1>>% -> <<2>>%)|r', pcgain, pccurrent )
			else
				pctexts = '|c00FF00RP|r +'..rdText
			end
			zo_strformat( '|c00FF00RP|r '..rdText..' |c736F6E(+<<1>>% -> <<2>>%)|r', pcgain, pccurrent )
			newDrop:SetLabel( zo_strformat('<<1>> |c736F6E->|r <<2>>', string.format("%+d",difference), pctexts ) )
			
        elseif (displayMode == LootDrop_sListBoxHalfExtended) then
			local pccurrent = 100
			local maxRank = 50
			local maxRankPointsAt = GetNumPointsNeededForAvARank(maxRank)
	
			if (pointsNeededForRank>0 and pointsNeededForRank ~= maxRankPointsAt) then
				local gDif = 100*(difference/pointsNeededForRank) -- show decimal values if difference is <1%
				pccurrent = math.floor(100*(actualPointsInRank/pointsNeededForRank))
			end
	
	        local RPstring = "" 
	        if difference ~= rdifference then RPstring = '|c00FF00RP|r'..rdText..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"") end
	
			local pctexts = ""
			if rdifference > 0 then
				pctexts = zo_strformat( RPstring..zo_iconTextFormatNoSpace(rankIcon,28,28,"")..'|c808080(<<1>>%)|r', pccurrent )
			else
				pctexts = RPstring
			end
			zo_strformat( '|c00FF00RP|r '..rdText..' |c736F6E<<1>>%|r', pccurrent )
			newDrop:SetLabel( zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..'<<2>>', string.format("%+d",difference), pctexts ) )
			
		else
			newDrop:SetLabel( zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..'<<2>>', string.format("%+d",difference), '|c00FF00RP|r '..rdText ) )
		end
	end

	if (self.db.DbgLogAP) then
		local text = ""
		if rdifference > 0 then
			text = zo_strformat('<<1>> |c736F6E->|r |c00FF00RP|r |cFFFFFF<<2>>|r |c736F6E (<<3>>/<<4>> = <<5>>%)|r', self:FormatAmount(RealAPDiff), RealRPDiff, self:FormatAmount(actualPointsInRank), self:FormatAmount(pointsNeededForRank), tostring(math.floor(100*(actualPointsInRank/pointsNeededForRank))))
		else
			text = zo_strformat('<<1>> |c736F6E->|r |c00FF00RP|r |cFFFFFF+<<2>>|r', self:FormatAmount(RealAPDiff), RealRPDiff)
		end
		self:ChatOutput(LootDrop_sApIcon, 1, text, 'AP', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnTVUpdate( newTelvarStones, oldTelvarStones )
	local difference = newTelvarStones - oldTelvarStones
	local displayMode = self.db.telvar

	if (self.current_telvar == newTelvarStones or difference == 0 or displayMode == LootDrop_sListBoxNo) then return end
	self.current_telvar = newTelvarStones

	local RealDiff=difference
	local pop = false
	local newDrop = nil
	
	local TVmulti = zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..GetTelvarStoneMultiplier(GetTelvarStoneMultiplierThresholdIndex()).."x"

	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._tvId ) then
			newDrop = self:Get( self._tvId )
			if ( newDrop ) then
				pop = true
				difference = difference + self._tvLastVal
			end
		end

		if ( not newDrop ) then
			newDrop, self._tvId = self:Acquire()
		end
	end

	self._tvLastVal = difference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFF66'

		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( LootDrop_sTVIcon )
		
		if (displayMode == LootDrop_sListBoxExtended) then
			newDrop:SetLabel(zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_iconTextFormatNoSpace("esoui/art/mainmenu/menubar_inventory_up.dds",28,28,"")..'<<2>>'..TVmulti, string.format("%+d",difference), self:FormatAmount(newTelvarStones)))
		else
			newDrop:SetLabel(string.format("%+d",difference) )
		end
	end

	if (self.db.DbgLogTelvar) then
		local text=zo_strformat('<<1>>  |c736F6E-> <<2>>|r', self:FormatAmount(RealDiff), self:FormatAmount(newTelvarStones))
		self:ChatOutput(LootDrop_sTVIcon, 1, text, '', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnWVoucherUpdate( newWVouchers, oldWVouchers )
	local difference = newWVouchers - oldWVouchers
	local displayMode = self.db.wvoucher

	if (self.current_writv == newWVouchers or difference == 0 or displayMode == LootDrop_sListBoxNo) then return end
	self.current_writv = newWVouchers

	local RealDiff=difference
	local pop = false
	local newDrop = nil

	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._wVoucherId ) then
			newDrop = self:Get( self._wVoucherId )
			if ( newDrop ) then
				pop = true
				difference = difference + self._wVoucherLastVal
			end
		end

		if ( not newDrop ) then
			newDrop, self._wVoucherId = self:Acquire()
		end
	end

	self._wVoucherLastVal = difference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFF66'

		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( LootDrop_sWVoucherIcon )
		
		if (displayMode == LootDrop_sListBoxExtended) then
			newDrop:SetLabel(zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_iconTextFormatNoSpace("esoui/art/mainmenu/menubar_inventory_up.dds",28,28,"")..'<<2>>',  string.format("%+d",difference), self:FormatAmount(newWVouchers)))
		else
			newDrop:SetLabel( string.format("%+d",difference) )
		end
	end

	if (self.db.DbgLogWritVoucher) then
		local text=zo_strformat('<<1>>  |c736F6E-> <<2>>|r', self:FormatAmount(RealDiff), self:FormatAmount(newWVouchers))
		self:ChatOutput(LootDrop_sWVoucherIcon, 1, text, '', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnUndauntedUpdate( newUndaunted, oldUndaunted )
	local difference = newUndaunted - oldUndaunted
	local displayMode = self.db.undaunted

	if (self.current_undaunted == newUndaunted or difference == 0 or displayMode == LootDrop_sListBoxNo) then return end
	self.current_undaunted = newUndaunted

	local RealDiff=difference
	local pop = false
	local newDrop = nil
	
	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._undauntedId ) then
			newDrop = self:Get( self._undauntedId )
			if ( newDrop ) then
				pop = true
				difference = difference + self._undauntedLastVal
			end
		end

		if ( not newDrop ) then
			newDrop, self._undauntedId = self:Acquire()
		end
	end

	self._undauntedLastVal = difference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFF66'

		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( LootDrop_sUndauntedIcon )
		
		if (displayMode == LootDrop_sListBoxExtended) then
			newDrop:SetLabel(zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_iconTextFormatNoSpace("esoui/art/inventory/inventory_currencytab_accountwide_up.dds",28,28,"")..'<<2>>', string.format("%+d",difference), self:FormatAmount(newUndaunted)))
		else
			newDrop:SetLabel( string.format("%+d",difference) )
		end
	end

	if (self.db.DbgLogUndauntedKey) then
		local text=zo_strformat('<<1>>  |c736F6E-> <<2>>|r', self:FormatAmount(RealDiff), self:FormatAmount(newUndaunted))
		self:ChatOutput(LootDrop_sUndauntedIcon, 1, text, '', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnTransmuteUpdate( newTransmute, oldTransmute )
	local difference = newTransmute - oldTransmute
	local displayMode = self.db.transmute
	local max = GetMaxPossibleCurrency(CURT_CHAOTIC_CREATIA, CURRENCY_LOCATION_ACCOUNT)

	if (self.current_transmute == newTransmute or difference == 0 or displayMode == LootDrop_sListBoxNo) then return end
	self.current_transmute = newTransmute

	local RealDiff=difference
	local pop = false
	local newDrop = nil

	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._transmuteId ) then
			newDrop = self:Get( self._transmuteId )
			if ( newDrop ) then
				pop = true
				difference = difference + self._transmuteLastVal
			end
		end

		if ( not newDrop ) then
			newDrop, self._transmuteId = self:Acquire()
		end
	end

	self._transmuteLastVal = difference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFF66'

		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( LootDrop_sTransmuteIcon )
		
		if (displayMode == LootDrop_sListBoxExtended) then
			newDrop:SetLabel(zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_iconTextFormatNoSpace("esoui/art/inventory/inventory_currencytab_accountwide_up.dds",28,28,"")..'<<2>>/'..max, string.format("%+d",difference), self:FormatAmount(newTransmute)))
		else
			newDrop:SetLabel( string.format("%+d",difference) )
		end
	end

	if (self.db.DbgLogTransmuteCrystal) then
		local text=zo_strformat('<<1>>  |c736F6E-> <<2>>|r', self:FormatAmount(RealDiff), self:FormatAmount(newTransmute))
		self:ChatOutput(LootDrop_sTransmuteIcon, 1, text, '', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnETicketUpdate( newETicket, oldETicket )
	local difference = newETicket - oldETicket
	local displayMode = self.db.eticket
	
	local max = GetMaxPossibleCurrency(CURT_EVENT_TICKETS, CURRENCY_LOCATION_ACCOUNT)

	if (self.current_eticket == newETicket or difference == 0 or displayMode == LootDrop_sListBoxNo) then return end
	self.current_eticket = newETicket

	local RealDiff=difference
	local pop = false
	local newDrop = nil

	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._eticketId ) then
			newDrop = self:Get( self._eticketId )
			if ( newDrop ) then
				pop = true
				difference = difference + self._eticketLastVal
			end
		end

		if ( not newDrop ) then
			newDrop, self._eticketId = self:Acquire()
		end
	end

	self._eticketLastVal = difference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFF66'

		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( LootDrop_sETicketIcon )
		
		if (displayMode == LootDrop_sListBoxExtended) then
			newDrop:SetLabel(zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_iconTextFormatNoSpace("esoui/art/inventory/inventory_currencytab_accountwide_up.dds",28,28,"")..'<<2>>/'..max, string.format("%+d",difference), self:FormatAmount(newETicket)))
		else
			newDrop:SetLabel( string.format("%+d",difference) )
		end
	end

	if (self.db.DbgLogEventTicket) then
		local text=zo_strformat('<<1>>  |c736F6E-> <<2>>|r', self:FormatAmount(RealDiff), self:FormatAmount(newETicket))
		self:ChatOutput(LootDrop_sETicketIcon, 1, text, '', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:OnEndeavorUpdate( newEndeavor, oldEndeavor )
	local difference = newEndeavor - oldEndeavor
	local displayMode = self.db.Endeavor

	if (self.current_Endeavor == newEndeavor or difference == 0 or displayMode == LootDrop_sListBoxNo) then return end
	self.current_Endeavor = newEndeavor

	local RealDiff = difference
	local pop = false
	local newDrop = nil

	if displayMode ~= LootDrop_sListBoxNo then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._EndeavorId ) then
			newDrop = self:Get( self._EndeavorId )
			if ( newDrop ) then
				pop = true
				difference = difference + self._EndeavorLastVal
			end
		end

		if ( not newDrop ) then
			newDrop, self._EndeavorId = self:Acquire()
		end
	end

	self._EndeavorLastVal = difference

	if displayMode ~= LootDrop_sListBoxNo then
		local c = 'FFFF66'

		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( LootDrop_sEndeavorIcon )
		
		if (displayMode == LootDrop_sListBoxExtended) then
			newDrop:SetLabel(zo_strformat('<<1>>'..zo_iconTextFormatNoSpace("esoui/art/crafting/crafting_enchanting_glyphslot_empty.dds",15,15,"")..zo_iconTextFormatNoSpace("esoui/art/inventory/inventory_currencytab_accountwide_up.dds",28,28,"")..'<<2>>', string.format("%+d",difference), self:FormatAmount(newEndeavor)))
		else
			newDrop:SetLabel( string.format("%+d",difference) )
		end
	end

	if (self.db.DbgLogEndeavor) then
		local text=zo_strformat('<<1>>  |c736F6E-> <<2>>|r', self:FormatAmount(RealDiff), self:FormatAmount(newEndeavor))
		self:ChatOutput(LootDrop_sEndeavorIcon, 1, text, '', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:CompanionXPUpdate(companionId, previousLevel, previousExperience, currentExperience)
	local gain = currentExperience - previousExperience
	if ( gain <= 0 ) then return end -- no gain so nothing to display

	local companionIcon = GetCollectibleIcon(GetCompanionCollectibleId(companionId))
	local iSize = tostring(self.db.FontSize)
	local cn = self:Split(GetCompanionName(companionId), " ")
	local companionName = "|c9DFE00"..zo_strformat('<<1>>', cn[1]) .. "|r " .. "|t"..iSize..":"..iSize..":"..LootDrop_sXpIcon.."|t" .. " "
	local level, currentXpInLevel, totalXpInLevel, isMaxLevel = ZO_COMPANION_MANAGER:GetLevelInfo()
	local displayMode = self.db.companionXP
	local companionLevel =  L.LevelPsijic.." "..level

	local xpForLevelUp
	if not isMaxLevel then
		xpForLevelUp = totalXpInLevel
	else
		xpForLevelUp = 0
	end
	local RealDiff = gain
	local pop = false
	local newDrop = nil
	
	if (displayMode ~= LootDrop_sListBoxNo) then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._xpCompanionId ) then
			newDrop = self:Get( self._xpCompanionId )
			if ( newDrop ) then
				pop = true
				gain = gain + self._xpCompanionLastVal
			end
		end
		if ( not newDrop ) then
			newDrop, self._xpCompanionId = self:Acquire()
		end
	end

	self._xpCompanionLastVal = gain

	if (displayMode ~= LootDrop_sListBoxNo) then
		local c = 'FFFFFF'
		local xp = ""
		if (self.db.sListStyle==LootDrop_sDefPawkette) then
			c = '00FF00'
		elseif self.db.sListStyle==LootDrop_sDefESOclassic then	
		    xp = "xp"
		end
		
		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( companionIcon )

		if (displayMode == LootDrop_sListBoxExtended) then
			local pcgain = 0
			local pccurrent = 100
	
			if (xpForLevelUp > 0) then
				local gDif = 100*(gain/xpForLevelUp) -- show decimal values if gain is <1%
				pccurrent = math.floor(100*(currentExperience/xpForLevelUp))
				pcgain = (gDif < 1) and string.format("%.2f",tostring(gDif)) or math.floor(gDif)
			end
	
			local pctexts = zo_strformat( '|c736F6E(+<<1>>% -> <<2>>%)|r', pcgain, pccurrent )
			if isMaxLevel then
				newDrop:SetLabel( companionName .. zo_strformat('<<1>>', string.format("%+d",gain)))
			else
				newDrop:SetLabel( companionName .. zo_strformat('<<1>> <<2>>', string.format("%+d",gain), pctexts))
			end
		elseif (displayMode == LootDrop_sListBoxHalfExtended) then
			local pccurrent = 100
	
			if (xpForLevelUp > 0) then
				local gDif = 100*(gain/xpForLevelUp) -- show decimal values if gain is <1%
				pccurrent = math.floor(100*(currentExperience/xpForLevelUp))
			end
	
			local pctexts = zo_strformat("|c9DFE00"..companionLevel..' |r|c808080(<<1>>%)|r', pccurrent)
			if isMaxLevel then
				newDrop:SetLabel( companionName .. zo_strformat('<<1>>'..xp, string.format("%+d",gain)))
			else
				newDrop:SetLabel( companionName .. zo_strformat('<<1>>'..xp..' <<2>>', string.format("%+d",gain), pctexts))
			end
		else
			newDrop:SetLabel( string.format("%+d",gain) )
		end
	end

	if (self.db.DbgLogCXp) then
		local text = ""
		if isMaxLevel then
			text = zo_strformat('<<1>>', self:FormatAmount(RealDiff))
		else
			text = zo_strformat('<<1>>  |c736F6E-> <<2>>/<<3>> (<<4>>%)|r', self:FormatAmount(RealDiff), self:FormatAmount(currentExperience), self:FormatAmount(xpForLevelUp), tostring(math.floor(100*(currentExperience/xpForLevelUp))))
		end
		self:ChatOutput(companionIcon, 1, companionName.." "..text, 'XP', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
function LootDrop:CompanionRapportUpdate(companionId, previousRapport, currentRapport)
	local gain = currentRapport - previousRapport
	if ( gain == 0 ) then return end -- no gain so nothing to display

	local companionIcon = GetCollectibleIcon(GetCompanionCollectibleId(companionId))
	local rdIcon = (gain > 0) and LootDrop_sRapportUpIcon or LootDrop_sRapportDownIcon
	local iSize = tostring(self.db.FontSize)
	local companionName = "|c9DFE00"..zo_strformat('<<1>>', GetCompanionName(companionId)) .. "|r " .. "|t"..iSize..":"..iSize..":"..rdIcon.."|t" .. " "
	local displayMode = self.db.companionRapport
	local RealDiff = gain
	local pop = false
	local newDrop = nil

	if (displayMode ~= LootDrop_sListBoxNo) then -- allowing to enable chat output when loot display disabled (Phinix)
		if ( self._rapportId ) then
			newDrop = self:Get( self._rapportId )
			if ( newDrop ) then
				pop = true
				gain = gain + self._rapportLastVal
			end
		end
		if ( not newDrop ) then
			newDrop, self._rapportId = self:Acquire()
		end
	end

	self._rapportLastVal = gain

	if (displayMode ~= LootDrop_sListBoxNo) then
		local c = 'FFFFFF'
		if (self.db.sListStyle==LootDrop_sDefPawkette) then
			c = '00FF00'
		end
		newDrop:SetTimestamp( GetFrameTimeMilliseconds() )
		newDrop:SetBackground()
		newDrop:SetLabelSize( self.db.FontSize )
		newDrop:SetRarity( ZO_ColorDef:New( c ), self.db.rarity )
		newDrop:SetIcon( companionIcon )
		newDrop:SetLabel(companionName .. zo_strformat('<<1>>', string.format("%+d",gain)))
	end

	if (self.db.DbgLogCRpt) then
		local text = ""
		local rLevelDesc = zo_strformat('<<1>>', GetActiveCompanionRapportLevelDescription(GetActiveCompanionRapportLevel()))
		if (displayMode == LootDrop_sListBoxExtended) then
			text = companionName .. zo_strformat('<<1>> (<<2>>)', string.format("%+d",RealDiff), rLevelDesc)
		else
			text = companionName .. zo_strformat('<<1>>', string.format("%+d",RealDiff))
		end
		self:ChatOutput(companionIcon, 1, text, 'RP', true)
	end

	if ( pop ) then
		local anim = self._pop:Apply( newDrop.control )
		anim:Forward()
	end
end
-------------------------------------------------------------------------------
--- Called when the amount of a special currency you have changes
-- Sends to individual update functions
function LootDrop:OnCurrencyUpdate(currencyType, currencyLocation, newAmount, oldAmount, reason)
	if currencyType == CURT_UNDAUNTED_KEYS then
		self:OnUndauntedUpdate( newAmount, oldAmount )
	elseif currencyType == CURT_CHAOTIC_CREATIA then
		self:OnTransmuteUpdate( newAmount, oldAmount )
	elseif currencyType == CURT_EVENT_TICKETS then
		self:OnETicketUpdate( newAmount, oldAmount )
	elseif currencyType == CURT_ENDEAVOR_SEALS then
		self:OnEndeavorUpdate( newAmount, oldAmount )
	end
end
-------------------------------------------------------------------------------
--- Called when group is joined/left/changes.
-- Maintains table of account name indexed by character name strings so loot functions can access account name (phinix)
function LootDrop:OnGroupChanged()
	LootDrop.GroupNames = {}
	if IsUnitGrouped("player") then
		if (self.db.DbgLogOthers) and self.db.lootdrop_gname ~= 0 then
			local groupSize = GetGroupSize()
			for s = 1, groupSize do
				local unitTag = GetGroupUnitTagByIndex(s)
				if (DoesUnitExist(unitTag)) then
					local displayName = zo_strformat(SI_UNIT_NAME, GetUnitDisplayName(unitTag))
					local unitName = zo_strformat(SI_UNIT_NAME, GetUnitName(unitTag))
					LootDrop.GroupNames[unitName] = displayName
				end
			end
		end
	end
end
-------------------------------------------------------------------------------
--- Getter for the control xml element
-- @treturn table 
function LootDrop:GetControl()
	return self.control
end
-------------------------------------------------------------------------------
function LootDrop_Initialized( self )
    LootDrop:New( self )
end
-------------------------------------------------------------------------------
function LootDrop:ChatOutput(iconFilename, quantity, text, tag, mine, unitName, quality, value)
	local DbgLogMine = self.db.DbgLogMine
	local DbgLogMineQlty = self.db.DbgLogMineQlty
	local DbgLogOthers = self.db.DbgLogOthers
	local DbgLogOthersQlty = self.db.DbgLogOthersQlty
	local lootdrop_gname = self.db.lootdrop_gname

	local function CreateIcon(filename, width, height)
		return zo_iconFormat(filename, width or 16, height or 16)
	end

	if (mine and not DbgLogMine) then return end
	if (not mine and not DbgLogOthers) then return end

	if tag == 'INV' or tag == 'JUNK' or tag == 'MAIL' then
		local qCheck = (quality ~= nil) and quality or 0
		if (mine and DbgLogMine) and (qCheck < DbgLogMineQlty) then return end
		if (not mine and DbgLogOthers) and (qCheck < DbgLogOthersQlty) then return end
	end

	if not iconFilename or iconFilename == '' then
		iconFilename = [[/esoui/art/icons/icon_missing.dds]]
	end

	local dbgLogTime = ""
	if self.db.DbgLogTime then
		dbgLogTime = string.format("[%s]:", GetTimeString())
	end

	local icon = CreateIcon(iconFilename)
	local tUN = zo_strformat(SI_UNIT_NAME, unitName)

	if not mine then -- set the custom display of group name if selected (phinix)
		if lootdrop_gname ~= 0 then
			if lootdrop_gname == 1 then
				if LootDrop.GroupNames[tUN] ~= nil then
					tUN = LootDrop.GroupNames[tUN]
				end
			elseif lootdrop_gname == 2 then
				if LootDrop.GroupNames[tUN] ~= nil then
					tUN = tUN.."("..LootDrop.GroupNames[tUN]..")"
				end
			end
		end
	end

--	local dbgText2 = zo_strformat('<<1[//$dx]>> <<2>>', quantity, text)  -- this class syntax prevents quantity display in Russian client, maybe others (phinix)
	local dbgText2 = (quantity > 1) and tostring(quantity).."x "..text or text

	if tag == 'INV' or tag == 'JUNK' or tag == 'MAIL' then
		if mine then
		--	dbgText2 = zo_strformat( '<<1[//$dx]>> <<2>> |c736F6E(<<3>>)|r', quantity, text, self.ItemToPrint.nb)
			dbgText2 = (quantity > 1) and tostring(quantity).."x "..text.." |c736F6E("..self.ItemToPrint.nb..")|r" or text.." |c736F6E("..self.ItemToPrint.nb..")|r"
		else
		--	dbgText2 = zo_strformat( '<<1[//$dx]>> <<2>>', quantity, text)
			dbgText2 = (quantity > 1) and tostring(quantity).."x "..text or text
		end

		if ((self.db.DbgLogItemStyle) and (self.ItemToPrint.itemStyle ~= nil)) then -- show item style if set in options
			dbgText2 = dbgText2 .. self.ItemToPrint.itemStyle
		end

		if (self.db.DbgLogItemTrait) then -- show item trait if set in options
			local traitType, traitDescription = GetItemLinkTraitInfo(text)
			if traitType ~= ITEM_TRAIT_TYPE_NONE and traitDescription ~= "" then
				local traitName = GetString("SI_ITEMTRAITTYPE", traitType)
				if traitName ~= "" then
					local traitInformation = GetItemTraitInformationFromItemLink(text)
					local formattedTraitName = zo_strformat(SI_ITEM_FORMAT_STR_ITEM_TRAIT_HEADER, traitName)
					dbgText2 = dbgText2 .. " |cFFFFFF["..formattedTraitName.."]|r"
				end
			end
		end

		if (self.db.DbgLogItemValue) then
			dbgText2 = dbgText2 .. value
		end
	end

	local dbgText3='.'
	if ((tag ~= '') and (self.db.DbgLogTag)) then dbgText3='(' .. tag .. ').' end
	
	if mine then
		CHAT_SYSTEM:AddMessage(zo_strformat( '<<1>> <<2>> <<3>> <<4>>', dbgLogTime, icon, dbgText2, dbgText3))
	else
		CHAT_SYSTEM:AddMessage(zo_strformat( "<<1>> <<2>>: <<3>> <<4>>", dbgLogTime, tUN, icon, dbgText2))
	end

end
-------------------------------------------------------
function LootDrop:Split(s, delimiter)
    result = {}
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        tinsert(result, match)
    end
	
	if result then return result
	else return s
	end
    
end
------------------------------------------------------
function LootDrop:NoDuplicates(entry) -- terminate previous entries with text containing the new entry name  
    if entry == nil or #self._active == 0 or #self._active == nil then return end
    local text = string.gsub(entry.label:GetText(), "%L+", "")
    	
	local timestamp = entry.timestamp

	local v = 1
	local oldEntry = nil
	local oldText = nil
	
	while( v <= #self._active ) do
		oldEntry = self._active[ v ]
		local oldText = string.gsub(oldEntry.label:GetText(), "%L+", "") 
		local oldTimestamp = oldEntry.timestamp
		
		if oldText == nil or oldText == "" then break end
		
		if oldText == text and oldTimestamp < timestamp then
		   self:Release(oldEntry)
		   tinsert( self.dirty_flags, DirtyFlags.LAYOUT )
		   --CHAT_SYSTEM:AddMessage("|cFFFFFFfound: |r"..text.."|cFFFFFF in |r"..oldText)
		   return
		end
		v = v + 1
	end
end

